void *malloc(unsigned long);
typedef unsigned u;

static const u prog[];
static const u prog_size;
static u root[];
static const u root_size;

enum { FORWARD = 27, REDUCING = 9 };

enum { TOP = 1<<24 };
u *mem, *altmem, *sp, *spTop, hp;

static inline u isAddr(u n) { return n>=128; }

static u evac(u n) {
  if (!isAddr(n)) return n;
  u x = mem[n];
  while (isAddr(x) && mem[x] == 'T') {
    mem[n] = mem[n + 1];
    mem[n + 1] = mem[x + 1];
    x = mem[n];
  }
  if (isAddr(x) && mem[x] == 'K') {
    mem[n + 1] = mem[x + 1];
    x = mem[n] = 'I';
  }
  u y = mem[n + 1];
  switch(x) {
    case FORWARD: return y;
    case REDUCING:
      mem[n] = FORWARD;
      mem[n + 1] = hp;
      hp += 2;
      return mem[n + 1];
    case 'I':
      mem[n] = REDUCING;
      y = evac(y);
      if (mem[n] == FORWARD) {
        altmem[mem[n + 1]] = 'I';
        altmem[mem[n + 1] + 1] = y;
      } else {
        mem[n] = FORWARD;
        mem[n + 1] = y;
      }
      return mem[n + 1];
    default: break;
  }
  u z = hp;
  hp += 2;
  mem[n] = FORWARD;
  mem[n + 1] = z;
  altmem[z] = x;
  altmem[z + 1] = y;
  return z;
}

static void gc() {
  hp = 128;
  u di = hp;
  sp = altmem + TOP - 1;
  for(u i = 0; i < root_size; i++) root[i] = evac(root[i]);
  *sp = evac(*spTop);
  while (di < hp) {
    u x = altmem[di] = evac(altmem[di]);
    di++;
    if (x != 'F' && x != '#') altmem[di] = evac(altmem[di]);
    di++;
  }
  spTop = sp;
  u *tmp = mem;
  mem = altmem;
  altmem = tmp;
}

static inline u app(u f, u x) {
  mem[hp] = f;
  mem[hp + 1] = x;
  hp += 2;
  return hp - 2;
}

static inline u arg(u n) { return mem[sp [n] + 1]; }
static inline u num(u n) { return mem[arg(n) + 1]; }

static inline void lazy(u height, u f, u x) {
  u *p = mem + sp[height];
  *p = f;
  *++p = x;
  sp += height - 1;
  *sp = f;
}

static void lazy3(u height,u x1,u x2,u x3){u*p=mem+sp[height];sp[height-1]=*p=app(x1,x2);*++p=x3;*(sp+=height-2)=x1;}

static inline u apparg(u i, u j) { return app(arg(i), arg(j)); }

static void foreign(u n);

static void run() {
  for(;;) {
    if (mem + hp > sp - 8) gc();
    u x = *sp;
    if (isAddr(x)) *--sp = mem[x]; else switch(x) {
      case 'F': foreign(arg(1)); break;
      case 'Y': lazy(1, arg(1), sp[1]); break;
      case 'Q': lazy(3, arg(3), apparg(2, 1)); break;
      case 'S': lazy3(3, arg(1), arg(3), apparg(2, 3)); break;
      case 'B': lazy(3, arg(1), apparg(2, 3)); break;
      case 'C': lazy3(3, arg(1), arg(3), arg(2)); break;
      case 'R': lazy3(3, arg(2), arg(3), arg(1)); break;
      case 'V': lazy3(3, arg(3), arg(1), arg(2)); break;
      case 'I': sp[1] = arg(1); sp++; break;
      case 'T': lazy(2, arg(2), arg(1)); break;
      case 'K': lazy(2, 'I', arg(1)); break;
      case ':': lazy3(4, arg(4), arg(1), arg(2)); break;
      case '#': lazy(2, arg(2), sp[1]); break;
      case '=': num(1) == num(2) ? lazy(2, 'I', 'K') : lazy(2, 'K', 'I'); break;
      case 'L': num(1) <= num(2) ? lazy(2, 'I', 'K') : lazy(2, 'K', 'I'); break;
      case '*': lazy(2, '#', num(1) * num(2)); break;
      case '/': lazy(2, '#', num(1) / num(2)); break;
      case '%': lazy(2, '#', num(1) % num(2)); break;
      case '+': lazy(2, '#', num(1) + num(2)); break;
      case '-': lazy(2, '#', num(1) - num(2)); break;
      case '.': return;
      case FORWARD: return;  // die("stray forwarding pointer");
      default: return;  // printf("?%u\n", x); die("unknown combinator");
    }
  }
}

void rts_reduce(u n) {
  *(sp = spTop) = app(app(n, '?'), '.');
  run();
}

#if __has_attribute(export_name)
void rts_init() __attribute__((export_name("rts_init")));
#endif
void rts_init() {
  mem = malloc(TOP * sizeof(u)); altmem = malloc(TOP * sizeof(u));
  hp = 128;
  for (u i = 0; i < prog_size; i++) mem[hp++] = prog[i];
  spTop = mem + TOP - 1;
}

static int env_argc;
int getargcount() { return env_argc; }
static char **env_argv;
int getargchar(int n, int k) { return env_argv[n][k]; }

#define EXPORT(f, sym, n) void f() asm(sym) __attribute__((export_name(sym))); void f(){rts_reduce(root[n]);}
int putchar(int);
int getchar();
int getargcount();
int getargchar(int,int);
static void foreign(u n) {
  switch(n) {
case 3: {u r = putchar(num(2)); lazy(4, app(arg(4), app('#', r)), arg(3)); break;}
case 2: {u r = getchar(); lazy(3, app(arg(3), app('#', r)), arg(2)); break;}
case 1: {u r = getargcount(); lazy(3, app(arg(3), app('#', r)), arg(2)); break;}
case 0: {u r = getargchar(num(2), num(3)); lazy(5, app(arg(5), app('#', r)), arg(4)); break;}

  }
}
static const u prog[]={81,37,81,47,81,42,81,45,81,43,140,75,67,142,84,63,138,46,138,46,84,150,152,43,35,1,81,76,81,61,81,76,81,61,164,166,66,75,168,170,66,75,172,84,66,75,176,178,66,75,180,182,66,75,184,84,66,186,66,75,190,192,66,75,194,198,66,196,66,75,200,84,66,202,66,75,206,208,66,75,210,75,66,75,214,218,66,216,66,75,220,224,66,222,66,75,226,84,66,67,230,232,66,75,234,84,66,236,66,75,240,244,66,242,66,75,246,84,66,248,66,75,252,256,66,254,66,75,258,262,66,260,66,75,264,268,66,266,66,75,270,274,66,272,66,75,276,84,66,67,280,282,66,75,284,286,66,75,288,290,66,75,292,84,66,294,66,75,298,300,66,75,302,304,66,75,306,310,66,308,66,75,312,84,66,314,66,75,318,320,66,75,322,326,66,324,66,75,328,332,66,330,66,75,334,84,66,336,66,75,340,342,66,75,344,346,66,75,348,75,66,75,75,352,75,73,75,75,358,75,66,75,362,372,66,364,66,366,66,368,66,370,66,67,374,382,66,376,66,378,66,380,66,67,384,390,66,386,66,388,66,67,392,396,66,394,66,67,398,84,66,67,402,84,66,67,406,84,66,67,410,84,66,67,414,416,66,75,418,420,66,75,422,424,66,75,426,428,66,75,430,84,66,75,434,436,66,75,438,440,66,75,442,444,66,75,446,448,66,75,450,84,66,452,66,75,456,460,66,458,66,75,462,466,66,464,66,75,468,472,66,470,66,75,474,480,66,476,66,478,66,75,482,488,66,484,66,486,66,75,490,84,66,67,494,498,66,496,66,75,500,504,66,502,66,75,506,512,66,508,66,510,66,75,514,520,66,516,66,518,66,75,522,528,66,524,66,526,66,75,530,84,66,67,534,536,66,75,538,542,66,540,66,75,544,548,66,546,66,75,550,554,66,552,66,75,556,84,66,558,66,75,562,566,66,564,66,75,568,572,66,570,66,75,574,578,66,576,66,75,580,584,66,582,66,75,586,84,66,588,66,75,592,596,66,594,66,75,598,602,66,600,66,75,604,84,66,67,608,612,66,610,66,75,614,620,66,616,66,618,66,75,622,84,66,67,626,630,66,628,66,75,632,84,66,634,66,75,638,640,66,75,642,644,66,75,646,84,66,75,650,652,66,75,654,656,66,75,658,84,66,660,66,75,664,666,66,75,668,672,66,670,66,75,674,84,66,676,66,75,680,684,66,682,66,75,686,690,66,688,66,75,692,84,66,694,66,75,698,702,66,700,66,75,704,708,66,706,66,75,710,84,66,67,714,716,66,75,718,84,66,720,66,75,724,728,66,726,66,75,730,84,66,732,66,75,736,746,66,738,66,740,66,742,66,744,66,75,748,756,66,750,66,752,66,754,66,67,758,764,66,760,66,762,66,67,766,770,66,768,66,67,772,84,66,67,776,84,66,75,780,84,66,782,66,75,786,84,66,75,75,790,75,73,75,75,796,75,66,75,84,73,84,73,84,804,75,73,84,75,84,810,75,73,84,75,84,73,818,820,66,84,84,822,70,0,70,1,70,2,84,830,70,3,834,84,66,67,838,842,66,840,66,75,844,84,66,67,75,73,850,814,66,852,67,854,856,858,66,66,860,808,66,66,864,868,66,866,82,75,870,802,66,872,66,66,84,160,84,156,84,158,84,154,884,890,66,886,66,888,82,792,892,904,83,894,896,898,66,83,900,798,66,902,66,83,906,912,66,908,66,910,82,794,914,920,66,916,66,918,82,788,922,798,66,67,926,928,66,84,930,942,66,932,67,934,936,938,66,66,940,73,82,75,944,960,66,946,67,948,950,952,66,66,954,956,66,66,958,73,82,846,962,1004,83,964,966,968,66,67,970,974,66,972,66,66,976,980,66,978,66,67,982,988,66,984,66,986,66,66,990,996,66,992,66,994,82,846,998,882,66,1000,66,1002,82,75,1006,924,66,798,1010,73,82,75,1014,73,82,1016,75,73,1020,1022,66,84,66,832,1026,1028,66,84,67,1030,1032,832,66,66,1036,1038,82,75,1040,73,82,846,1044,800,66,1046,66,1048,66,1034,1052,73,82,75,1056,73,66,1058,82,846,1062,1064,66,84,1066,1094,66,1068,67,1070,1072,1074,66,83,1076,1090,82,1078,1080,1086,82,1082,75,1084,75,846,1088,73,82,75,1092,73,66,66,1096,1112,66,1098,67,1100,1102,1104,66,66,1106,1108,66,66,1110,73,82,846,1114,1148,83,1116,1118,1120,66,67,1122,1126,66,1124,66,66,1128,1132,66,1130,66,67,1134,1140,66,1136,66,1138,66,66,1142,800,66,1144,66,1146,66,1054,1150,1060,66,800,1154,1172,83,1156,1158,1160,66,66,1162,1164,82,75,1166,1170,82,1168,35,0,800,874,1174,1182,66,1176,67,1178,1180,73,82,75,1184,1192,66,1186,67,1188,1190,836,66,66,1194,1196,66,1152,1198,134,82,1200,35,1,1204,84,66,67,84,1208,1210,1214,66,1212,1202,75,66,784,1218,1238,82,1220,67,1222,1224,1228,66,1226,1202,75,67,1230,1232,1236,66,1234,1202,75,66,784,84,784,1242,1248,82,1244,67,1246,1202,75,84,784,1252,1260,66,1254,83,1256,1258,84,66,67,1262,1250,83,1264,1266,1268,66,66,1270,1272,66,67,66,66,1276,1286,1250,1278,75,1280,1282,136,82,1284,35,1,35,0,1290,1324,83,1292,1294,1296,66,67,1298,1302,66,1300,66,67,1304,1310,66,1306,66,1308,66,1250,1312,1316,66,1314,66,66,1318,1322,66,1320,82,836,67,848,1326,812,82,75,1330,1348,66,1332,67,1334,1336,1338,66,67,1340,1344,66,1342,66,1250,1346,862,66,66,1350,812,82,75,1354,1360,66,1356,66,1358,66,67,1362,812,66,1364,67,1366,1368,1370,66,67,1372,1376,66,1374,66,1250,1378,1384,66,1380,66,1382,66,67,1386,1388,82,67,1390,1392,66,66,1394,1396,66,66,1398,802,66,66,1402,1422,82,1404,1406,1418,82,1408,1410,1414,82,1412,66,86,1416,67,66,66,1420,67,66,66,84,86,1426,1428,82,67,84,86,84,1432,1434,86,66,1436,808,1400,1440,1444,1442,1424,1328,1400,1446,73,66,828,1450,1452,66,138,1454,1456,82,46,1458,1462,66,1460,862,1424,1464,1470,82,1466,828,1468,35,10,1472,1438,66,1474,862,1424,1448,1478,1480,1484,58,1482,35,117,1486,1490,58,1488,35,110,1492,1496,58,1494,35,100,1498,1502,58,1500,35,101,1504,1508,58,1506,35,102,1510,1514,58,1512,35,105,1516,1520,58,1518,35,110,1522,1526,58,1524,35,101,1528,75,58,1530,35,100,1534,1542,66,1536,83,1538,1540,73,82,146,1544,1548,66,1546,66,75,1550,1554,66,1552,66,75,1556,1564,66,1558,66,1560,1562,73,1202,1476,1566,1568,82,75,1570,1572,66,1250,1574,1580,66,1576,66,1578,66,784,83,1202,1584,1586,66,67,1588,1590,82,73,1592,1594,66,1250,1596,67,66,1598,66,1600,67,66,1604,1582,66,1606,67,1608,1610,73,82,146,1614,1618,66,1616,82,846,1620,1624,66,1622,66,1250,1626,1632,66,1628,66,1630,66,1050,1634,800,66,67,1638,1640,82,75,1642,1644,66,1250,1646,1648,82,784,1650,73,66,83,67,1654,1250,836,1658,75,1250,1652,1662,836,82,75,1666,75,67,1668,1670,1672,66,1250,66,836,84,1664,1678,1664,66,1680,66,1656,1684,1688,66,1686,82,75,1690,1694,66,1692,66,1250,1696,1706,66,1698,66,1700,67,1702,1704,73,66,66,1708,1712,66,1710,66,67,1714,1720,66,1716,66,1718,66,67,1722,1728,66,1724,66,1726,82,784,1730,800,66,1732,66,1734,66,66,1738,1664,66,1740,66,1742,1744,75,1250,1054,1748,1664,66,1750,66,1752,1754,846,1250,1050,1758,1760,83,836,1762,1764,66,1756,1766,136,82,1768,35,1,1772,1784,66,1774,67,1776,1778,1780,66,66,1782,73,82,75,1786,1802,66,1788,67,1790,1792,1794,66,66,1796,1798,66,66,1800,73,82,75,1804,1770,83,1806,1808,1810,66,67,1812,1816,66,1814,66,66,1818,1822,66,1820,66,67,1824,1830,66,1826,66,1828,66,66,66,1832,66,836,1770,832,1838,73,82,73,84,1842,1844,1846,66,84,1848,1852,66,1850,66,84,1854,1018,66,66,1858,1900,82,1860,1862,1896,82,1864,1866,1892,82,1868,1870,1874,66,1872,66,84,1876,1884,82,1878,67,1880,1882,1018,66,66,1886,1888,66,66,1890,73,66,67,1894,73,66,66,1898,73,66,66,84,1902,1904,832,66,84,1908,1934,82,1910,1912,1930,82,1914,1916,1920,66,1918,66,84,1922,1924,66,66,1926,1928,66,84,66,1836,1932,73,66,66,84,1936,1938,832,66,84,1942,1836,66,1944,66,1008,84,1948,1950,73,83,832,1954,1956,66,84,1958,1960,66,75,832,75,1964,84,66,67,84,1968,1970,1978,66,1972,67,1974,1976,73,82,778,66,774,1982,2010,82,1984,1986,2002,82,1988,1990,1994,82,1992,66,774,1996,1998,66,66,2000,73,82,778,2004,2006,66,66,2008,73,82,778,84,774,2014,2020,82,2016,2018,73,82,778,84,774,2024,2038,82,2026,2028,2030,66,75,2032,2034,66,75,2036,75,66,75,2040,73,82,2042,35,0,2046,2052,66,2048,66,2050,82,73,2054,2060,66,2056,66,2058,66,83,2062,2066,66,2064,82,73,2068,2072,66,2070,66,83,2074,2080,66,2076,66,2078,66,67,2082,2084,66,67,2086,2090,66,2088,66,67,67,2092,2094,2096,66,67,2098,2102,66,2100,66,734,2104,2106,82,2022,2108,2110,66,66,2112,2114,66,136,2116,2022,66,2118,136,2120,35,1,2124,2128,66,2126,82,75,2130,2134,66,2132,82,75,734,2136,35,1,2140,2152,66,2142,66,2144,66,2146,67,2148,2150,73,82,146,2154,2160,66,2156,66,2158,66,75,2162,2044,66,2164,66,2166,66,2168,67,2170,2172,2174,66,67,2176,2044,66,2178,66,66,2182,2190,66,2184,66,2186,66,2188,82,146,2192,2204,66,2194,66,2196,66,2198,67,2200,2202,73,66,83,2206,2214,66,2208,66,2210,66,2212,66,75,2216,2242,66,2218,66,2220,66,2222,67,2224,2226,2228,66,66,2230,2232,66,66,2234,2236,66,67,2238,84,66,2240,66,66,2244,2256,66,2246,66,2248,66,2250,66,2252,66,2254,66,75,2258,2270,66,2260,66,2262,82,2264,2266,2044,66,2268,66,67,2272,2278,66,2274,66,2276,66,66,2280,2286,66,2282,66,2284,66,66,2288,2294,66,2290,66,2292,66,66,2296,2302,66,2298,66,2300,66,67,2304,2312,66,2306,66,2308,66,2310,66,67,2314,2324,66,2316,66,2318,66,2320,66,2322,66,67,2326,2338,66,2328,66,2330,66,2332,66,2334,66,2336,66,66,2340,2044,66,2342,66,2344,66,2346,67,2348,2350,2352,66,67,2354,2044,66,2356,66,66,2360,2374,66,2362,66,2364,67,2366,2368,2370,66,66,2372,73,82,146,2376,2382,66,2378,66,2380,66,75,2384,2410,66,2386,66,2388,66,2390,67,2392,2394,2396,66,67,2398,2402,66,2400,66,67,2404,2044,66,2406,66,2408,66,66,2412,2044,66,2414,66,67,2418,2426,66,2420,66,2422,66,2424,82,146,2428,2442,66,2430,66,2432,67,2434,2436,2438,66,66,2440,73,66,83,2444,2452,66,2446,66,2448,66,2450,66,75,2454,2478,66,2456,66,2458,66,2460,67,2462,2464,2466,66,66,2468,2470,66,66,2472,2474,66,66,2476,84,66,67,2480,2492,66,2482,66,2484,66,2486,66,2488,66,2490,66,75,2494,2576,66,2496,66,2498,66,2500,67,2502,2504,2506,66,67,2508,2512,66,2510,66,67,2514,2520,66,2516,66,2518,66,67,2522,2530,66,2524,66,2526,66,2528,66,67,2532,2542,66,2534,66,2536,66,2538,66,2540,66,67,2544,2556,66,2546,66,2548,66,2550,66,2552,66,2554,66,66,2558,2044,66,2560,66,2562,66,2564,67,2566,2568,2570,66,67,2572,2044,66,2574,66,66,2578,2044,66,2580,66,67,2584,2590,66,2586,66,2588,82,73,2592,2598,66,2594,66,2596,66,83,2600,2604,66,2602,82,73,2606,2610,66,2608,66,83,2612,2618,66,2614,66,2616,66,67,2620,2622,66,67,2624,2628,66,2626,66,67,67,2630,2632,2634,66,67,2636,2676,83,2638,2640,2642,66,83,2644,2648,66,2646,82,2044,2650,2656,66,2652,82,2654,35,1,2658,2664,66,2660,66,2662,798,878,2666,2668,82,2022,2670,2672,66,66,2674,2022,66,136,2678,2798,83,2680,2682,2684,66,83,2686,2754,82,2688,2690,2750,82,2692,75,2694,75,2696,75,2698,2700,2704,66,2702,82,2180,2706,2710,66,2708,82,2138,2712,2722,82,2714,2716,2022,66,2718,132,2720,35,3,2724,2726,66,66,2728,2732,66,2730,798,878,2734,2738,82,2736,35,1,2740,2742,66,136,2744,2022,66,2746,132,2748,35,2,2752,73,82,2044,2756,2758,66,83,2760,2770,82,2762,2764,2022,66,2766,132,2768,35,2,2772,2774,66,66,2776,2780,66,2778,798,878,2782,2786,82,2784,35,3,2788,2790,66,136,2792,2022,66,2794,132,2796,35,5,2800,2804,66,2802,82,2044,2806,2850,83,2808,2810,2812,66,67,2814,2842,66,2816,67,2818,2820,2824,66,2822,798,878,2826,2830,82,2828,35,3,2832,2834,66,136,2836,2022,66,2838,132,2840,35,5,2844,2022,66,2846,132,2848,35,2,2852,2910,82,2854,75,2856,75,2858,75,2860,2862,2866,66,2864,82,2416,2868,2872,66,2870,82,2358,2874,2902,66,2876,67,2878,2880,2884,66,2882,798,878,2886,2890,82,2888,35,1,2892,2894,66,136,2896,2022,66,2898,132,2900,35,2,2904,2022,66,2906,132,2908,35,3,2912,73,82,2044,2916,2936,66,2918,83,2920,2922,2924,66,83,2926,2930,66,2928,66,67,2932,2122,66,2934,66,84,2938,2946,82,2940,2942,2944,66,67,67,734,2948,2950,66,83,2952,2956,66,2954,66,83,2958,2964,66,2960,66,2962,66,66,2966,2972,66,2968,66,2970,66,67,2974,2982,66,2976,66,2978,66,2980,66,67,2984,2994,66,2986,66,2988,66,2990,66,2992,66,83,2996,3008,66,2998,66,3000,66,3002,66,3004,66,3006,66,83,3010,3130,83,3012,3014,3016,66,83,3018,3022,66,3020,66,83,3024,3030,66,3026,66,3028,66,83,3032,3040,66,3034,66,3036,66,3038,66,83,3042,3052,66,3044,66,3046,66,3048,66,3050,66,83,3054,3066,66,3056,66,3058,66,3060,66,3062,66,3064,66,83,3068,3110,83,3070,3072,3074,66,83,3076,3080,66,3078,66,66,3082,3086,66,3084,66,83,3088,3094,66,3090,66,3092,66,66,3096,3102,66,3098,66,3100,66,66,3104,882,66,3106,66,3108,66,66,3112,2914,66,3114,66,3116,66,3118,67,3120,3122,3124,66,67,3126,2582,66,3128,66,66,3132,2914,66,3134,66,3136,66,3138,67,3140,3142,3144,66,67,3146,3150,66,3148,66,67,3152,2582,66,3154,66,3156,66,66,3160,3182,66,3162,66,3164,83,3166,3168,3170,66,83,3172,3176,66,3174,66,67,3178,2122,66,3180,66,84,3184,3204,82,3186,67,3188,3190,3192,66,66,3194,3196,66,67,3198,3202,66,3200,66,66,67,734,3206,3208,66,83,3210,3214,66,3212,66,83,3216,3222,66,3218,66,3220,66,83,3224,3232,66,3226,66,3228,66,3230,66,66,3234,3242,66,3236,66,3238,66,3240,66,67,3244,3254,66,3246,66,3248,66,3250,66,3252,66,83,3256,3268,66,3258,66,3260,66,3262,66,3264,66,3266,66,83,3270,3284,66,3272,66,3274,66,3276,66,3278,66,3280,66,3282,66,83,3286,3428,83,3288,3290,3292,66,83,3294,3298,66,3296,66,83,3300,3306,66,3302,66,3304,66,83,3308,3316,66,3310,66,3312,66,3314,66,83,3318,3328,66,3320,66,3322,66,3324,66,3326,66,83,3330,3342,66,3332,66,3334,66,3336,66,3338,66,3340,66,83,3344,3358,66,3346,66,3348,66,3350,66,3352,66,3354,66,3356,66,83,3360,3406,83,3362,3364,3366,66,66,3368,3370,66,83,3372,3376,66,3374,66,66,3378,3382,66,3380,66,83,3384,3390,66,3386,66,3388,66,66,3392,3398,66,3394,66,3396,66,66,3400,882,66,3402,66,3404,66,66,3408,3158,66,3410,66,3412,66,3414,66,3416,67,3418,3420,3422,66,67,3424,2582,66,3426,66,66,3430,3158,66,3432,66,3434,66,3436,66,3438,67,3440,3442,3444,66,67,3446,3450,66,3448,66,67,3452,2582,66,3454,66,3456,66,66,3460,3470,66,3462,66,3464,67,3466,3468,73,82,75,3472,3476,66,3474,66,75,3478,3484,66,3480,66,3482,82,784,3486,3492,66,3488,66,3490,66,66,3494,3500,66,3496,66,3498,66,67,3502,3510,66,3504,66,3506,66,3508,66,67,3512,3458,83,3514,3516,3518,66,83,3520,3524,66,3522,66,67,3526,3532,66,3528,66,3530,66,67,3534,3542,66,3536,66,3538,66,3540,66,66,3544,3458,83,3546,3548,3550,66,83,3552,3556,66,3554,66,67,3558,882,66,3560,66,3562,66,66,3566,3568,82,75,3570,3572,66,1582,3574,3578,66,3576,66,84,3580,3582,66,67,3584,2914,66,3586,66,67,3590,3592,66,89,3594,3604,66,3596,66,3598,83,3600,3602,84,66,67,3606,3612,66,3608,66,3610,66,75,3614,3624,66,3616,66,3618,66,3620,66,3622,66,67,3626,3642,66,3628,83,3630,3632,3634,66,66,3636,3638,66,66,3640,66,66,66,3644,3646,66,66,3648,3650,66,67,3652,3656,66,3654,66,67,66,3658,66,66,3662,75,3588,3664,3666,832,66,3668,66,836,3672,3674,66,696,696,3676,722,3678,3680,3684,58,3682,35,45,3686,75,58,3688,35,62,400,75,3694,678,66,560,3698,73,82,75,3702,3716,82,3704,3706,3708,66,75,3710,3696,66,3712,836,3714,35,124,3718,73,82,146,3722,3730,66,3724,83,3726,3728,3700,66,832,3732,3740,66,3734,82,3736,3692,3738,35,73,3742,3746,66,3744,66,832,3748,3752,66,3750,66,3690,3754,3828,82,3756,3758,3790,66,3760,3762,3764,1250,3670,712,3766,3768,3772,58,3770,35,99,3774,3778,58,3776,35,97,3780,3784,58,3782,35,115,3786,75,58,3788,35,101,1664,3792,3794,73,82,3796,75,3798,3800,3802,1250,3670,712,3804,3806,3810,58,3808,35,99,3812,3816,58,3814,35,97,3818,3822,58,3820,35,115,3824,75,58,3826,35,101,3830,3670,66,66,3834,3836,66,1012,3838,3864,1582,3840,3842,3844,66,75,3846,73,82,3848,3850,836,83,3852,3854,3856,66,66,3858,3860,66,832,836,3862,35,42,3866,75,832,3868,3870,75,58,3872,35,42,3876,3904,66,3878,83,3880,3882,3884,66,66,3886,3892,82,3888,3692,3890,35,58,3894,3898,800,3896,1060,874,3900,75,58,3902,35,58,3906,3936,66,3908,67,3910,3912,3914,66,83,3916,3922,66,3918,66,3920,1250,454,3924,532,66,3926,1582,3928,3930,3932,82,532,3934,492,66,66,67,1652,3940,3944,66,3942,66,84,3946,3956,66,3948,66,3950,83,3952,3954,832,66,66,3958,3978,82,3960,3962,3966,66,3964,82,3832,3968,3972,66,3970,66,66,3974,3976,66,3874,1664,3696,3980,3982,66,66,3984,3986,66,66,3988,3990,66,83,3992,3996,66,3994,66,832,3998,4002,66,4000,66,3690,1250,3670,4006,4018,83,4008,4010,4012,66,83,4014,3720,66,4016,66,836,4020,4022,82,73,4024,4026,66,83,4028,3938,66,4030,66,1664,4034,4046,83,4036,4038,4040,82,73,4042,4044,800,874,35,0,4048,4064,83,4050,4052,4054,66,66,4056,4058,66,4032,4060,130,82,4062,35,10,4066,4068,66,836,4070,4076,66,4072,136,4074,35,48,4078,128,82,4080,35,10,4084,4032,83,4086,4088,4094,82,4090,836,4092,35,48,4096,4098,800,874,35,0,4102,4108,66,4104,66,4106,82,144,4110,4144,66,4112,67,4114,4116,4118,66,83,4120,4124,66,4122,66,83,4126,4130,66,4128,82,75,4132,4136,66,4134,66,66,4138,4140,82,75,4142,73,66,66,4146,4150,66,4148,66,67,4152,4158,66,4154,66,4156,66,67,4160,4226,66,4162,83,4164,4166,4168,66,67,4170,4174,66,4172,66,66,4176,4180,66,4178,66,83,4182,4186,66,4184,82,75,4188,4192,66,4190,66,83,4194,4202,66,4196,67,4198,4200,73,66,66,4204,4206,66,67,67,4208,4210,4214,800,4212,1060,874,4216,4220,58,4218,35,73,4222,75,58,4224,35,79,4228,4238,66,4230,66,4232,66,4234,66,4236,66,75,4240,4246,66,4242,66,4244,66,67,4248,4260,66,4250,66,4252,66,4254,82,4256,4258,75,66,75,4262,4270,66,4264,66,4266,66,4268,66,83,4272,4280,66,4274,66,4276,66,4278,82,75,4282,4290,66,4284,66,4286,66,4288,66,83,4292,4304,66,4294,66,4296,66,4298,67,4300,4302,73,66,66,4306,4312,66,4308,66,4310,66,67,4314,4340,66,4316,66,4318,66,4320,67,4322,4324,4328,800,4326,1060,874,4330,4334,58,4332,35,45,4336,75,58,4338,35,62,4342,4360,83,4344,4346,4348,66,66,4350,4352,66,66,4354,4356,66,454,4358,4082,82,75,4362,4382,83,4364,4366,4368,66,66,4370,4372,66,67,4374,4376,66,4100,4378,136,82,4380,35,1,4384,4386,66,492,4388,4390,66,532,4392,4082,82,75,4396,73,83,4398,4400,4402,66,67,4404,4406,66,1250,4408,4416,66,4410,67,4412,4414,73,66,66,4418,4424,66,4420,66,4422,66,75,4426,4428,66,67,67,4430,2914,4432,924,878,4436,4440,66,4438,66,84,4442,4444,82,4394,4446,4448,66,83,4450,4454,66,4452,66,67,4456,4462,66,4458,66,4460,66,67,4464,4472,66,4466,66,4468,66,4470,66,67,4474,4484,66,4476,66,4478,66,4480,66,4482,66,66,4486,4502,66,4488,66,4490,67,4492,4494,4496,66,67,4498,360,66,4500,66,66,4504,4004,66,4506,66,1652,4510,4516,66,4512,66,4514,66,84,4518,4538,66,4520,82,4522,4524,4530,82,4526,1756,4528,35,0,1770,4532,75,4534,4536,4082,82,75,4540,4544,66,4542,66,83,4546,4552,66,4548,66,4550,66,67,4554,4562,66,4556,66,4558,66,4560,66,67,4564,4574,66,4566,66,4568,66,4570,66,4572,66,67,4576,4588,66,4578,66,4580,66,4582,66,4584,66,4586,66,67,4590,4604,66,4592,66,4594,66,4596,66,4598,66,4600,66,4602,66,67,4606,4622,66,4608,66,4610,66,4612,66,4614,66,4616,66,4618,66,4620,66,67,4624,4640,66,4626,66,4628,66,4630,66,4632,66,4634,66,4636,66,4638,66,67,4642,4656,66,4644,66,4646,66,4648,66,4650,66,4652,66,4654,66,67,4658,4670,66,4660,66,4662,66,4664,66,4666,66,4668,66,67,4672,4696,66,4674,66,4676,66,4678,67,4680,4682,4684,66,67,4686,4690,66,4688,66,66,4692,360,66,4694,66,66,4698,4704,66,4700,66,4702,66,67,4706,4714,66,4708,66,4710,66,4712,66,1652,4716,4720,66,4718,66,67,4722,4726,66,4724,82,73,4728,4732,66,4730,66,83,4734,4740,66,4736,66,4738,66,1770,4742,4750,66,4744,66,4746,66,4748,66,84,4752,4766,66,4754,66,4756,66,4758,66,4760,67,4762,4764,832,66,66,4768,4810,66,4770,82,4772,4774,4786,66,4776,66,4778,454,4780,4782,75,58,4784,35,64,4788,4802,66,4790,66,4792,492,4794,532,4796,4798,75,58,4800,35,64,67,4804,4806,532,66,4808,1250,454,4812,4816,66,4814,66,66,4818,4822,66,4820,66,66,4824,4828,66,4826,66,67,4830,4836,66,4832,66,4834,66,832,4838,4842,66,4840,66,400,4844,4848,66,4846,82,75,4850,404,66,4852,66,836,4856,4862,66,4858,66,4860,66,84,4864,4916,83,4866,4868,4870,66,83,4872,4876,66,4874,66,66,4878,4882,66,4880,66,67,4884,4890,66,4886,66,4888,66,66,4892,4898,66,4894,66,4896,66,360,4900,4906,82,4902,4904,836,82,75,4908,4910,66,66,4912,1652,3158,4914,924,878,4918,4924,66,4920,66,4922,66,836,4926,4932,66,4928,66,4930,66,774,4934,4936,82,832,4938,4940,66,66,4942,832,66,66,4946,4952,66,4948,66,4950,66,84,4954,5114,66,4956,67,4958,4960,4962,66,83,4964,4968,66,4966,66,67,4970,4976,66,4972,66,4974,66,67,4978,4986,66,4980,66,4982,66,4984,66,67,4988,4998,66,4990,66,4992,66,4994,66,4996,66,67,5000,5012,66,5002,66,5004,66,5006,66,5008,66,5010,66,83,5014,5024,66,5016,66,5018,66,5020,66,5022,66,67,5026,5048,66,5028,66,5030,67,5032,5034,5036,66,67,5038,5042,66,5040,66,66,5044,360,66,5046,66,66,5050,5054,66,5052,66,67,5056,5062,66,5058,66,5060,66,836,5064,5106,82,5066,5068,5080,83,5070,5072,5074,66,66,5076,5078,66,832,400,75,5082,5098,82,5084,5086,5094,66,5088,492,5090,3692,5092,35,70,5096,1274,66,3692,5100,5102,66,66,4100,5104,35,0,5108,5110,66,66,5112,832,66,66,5116,832,66,5118,66,836,5122,5124,66,84,5126,5134,66,5128,67,5130,5132,360,66,66,5136,5138,66,1652,1664,778,5142,5146,66,5144,66,84,5148,5194,66,5150,66,5152,67,5154,5156,5158,66,67,5160,5164,66,5162,66,67,5166,5172,66,5168,66,5170,66,67,5174,5182,66,5176,66,5178,66,5180,66,67,5184,360,66,5186,66,5188,66,5190,66,5192,66,66,5196,832,66,5198,66,836,5202,5204,82,84,5206,73,66,66,5210,5272,82,5212,5214,5218,66,5216,66,84,5220,5258,82,5222,5224,5226,66,84,5228,5244,82,5230,5232,5234,66,84,5236,5242,66,5238,66,5240,66,784,66,832,5246,5248,66,66,5250,5252,66,67,5254,5200,66,5256,82,75,5260,5262,66,66,5264,5266,66,67,5268,5200,66,5270,82,75,84,5274,5276,5278,66,84,5280,832,66,5282,66,784,5286,5318,82,5288,5290,5294,66,5292,66,84,5296,5304,82,5298,5300,5302,66,84,66,5200,5306,5308,66,66,5310,5312,66,67,5314,5200,66,5316,82,75,84,5320,812,5208,5324,5330,66,5326,66,5328,82,75,5332,5340,82,5334,5336,832,66,5338,66,784,5342,5344,66,83,5346,73,66,5348,66,66,5352,5354,66,84,5356,5322,66,5358,67,5360,5362,73,82,75,84,5366,5368,5372,66,5370,808,5208,812,5208,5376,5380,66,5378,66,84,5382,5388,66,5384,66,5386,82,784,5390,5392,82,5200,5394,5396,66,66,5398,5200,66,83,5402,5408,66,5404,82,5406,75,73,67,848,5412,5416,66,5414,82,75,67,848,5420,5426,82,5422,5424,75,812,5208,5428,5430,66,5374,5432,5418,83,5434,5436,836,5438,5208,848,5364,5442,5418,83,5444,5446,836,5448,5208,848,5364,5452,5464,83,5454,5456,5458,66,66,5460,836,5462,5208,848,5364,5466,5470,66,5468,66,5418,67,5472,5474,5364,5400,5208,5478,5486,66,5480,82,5482,5484,75,812,5208,5488,5450,66,5490,66,5374,5494,5496,66,5350,800,874,5500,5530,83,5502,5504,5506,66,83,5508,5512,66,5510,66,67,5514,5520,66,5516,66,5518,66,66,5522,5528,66,5524,66,5526,66,66,67,5400,5532,5536,66,5534,66,67,67,5410,5540,5550,5542,5546,5544,5364,5400,5208,5492,5548,35,45,5552,5568,5554,5564,5556,5560,5558,5208,5498,5364,5492,5562,35,45,5492,5566,35,10,5418,5570,5350,5572,5574,5576,1042,874,35,10,5418,5580,5582,5538,5374,5584,5586,5590,5588,1660,814,5364,5350,5592,5594,5608,83,5596,5598,5600,66,1050,5602,5606,82,5604,35,32,800,874,5610,5614,82,5612,35,10,800,874,5618,5620,82,5578,5622,5364,5410,5208,5626,5492,66,5616,5630,5634,66,5632,66,84,5636,5650,66,5638,67,5640,5642,5644,66,67,5646,5200,66,5648,82,75,5652,5656,66,5654,82,75,5658,5660,82,784,5662,5664,66,83,5666,5668,82,1008,5670,73,66,66,5674,5684,5676,5680,5678,5208,5498,5364,5624,5682,35,40,5624,5686,35,41,5350,5690,5692,5720,83,5694,5696,5698,66,1050,5700,5714,83,5702,5704,5706,66,1054,5708,5712,82,5710,35,122,798,878,5716,5718,798,878,35,97,5722,5726,82,5724,35,95,800,874,5350,5730,5732,5746,83,5734,5736,5738,66,1054,5740,5744,82,5742,35,90,798,878,5748,5750,798,878,35,65,5350,5754,5756,5770,83,5758,5760,5762,66,1054,5764,5768,82,5766,35,57,798,878,5772,5774,798,878,35,48,5350,5778,5780,5896,82,5782,5784,5788,58,5786,35,33,5790,5794,58,5792,35,35,5796,5800,58,5798,35,36,5802,5806,58,5804,35,37,5808,5812,58,5810,35,38,5814,5818,58,5816,35,42,5820,5824,58,5822,35,43,5826,5830,58,5828,35,46,5832,5836,58,5834,35,47,5838,5842,58,5840,35,60,5844,5848,58,5846,35,61,5850,5854,58,5852,35,62,5856,5860,58,5858,35,63,5862,5866,58,5864,35,64,5868,5872,58,5870,35,92,5874,5878,58,5876,35,94,5880,5884,58,5882,35,124,5886,5890,58,5888,35,45,5892,75,58,5894,35,126,1612,874,5900,5908,5902,5688,5904,836,5906,5208,848,5364,5418,5910,5912,5922,5374,5914,5916,5752,5374,5918,5920,5728,5374,5688,5492,5924,35,39,5616,5928,5930,5938,5932,5728,5934,836,5936,5208,848,5364,5418,5940,5942,5952,5374,5944,5946,5752,5374,5948,5950,5728,5374,5688,5492,5954,35,39,5616,5958,5960,5898,5628,5962,5964,5966,66,1034,5968,6206,82,5970,5972,6004,836,5974,5976,5980,58,5978,35,99,5982,5986,58,5984,35,108,5988,5992,58,5990,35,97,5994,5998,58,5996,35,115,6000,75,58,6002,35,115,6006,6032,836,6008,6010,6014,58,6012,35,100,6016,6020,58,6018,35,97,6022,6026,58,6024,35,116,6028,75,58,6030,35,97,6034,6084,836,6036,6038,6042,58,6040,35,105,6044,6048,58,6046,35,110,6050,6054,58,6052,35,115,6056,6060,58,6058,35,116,6062,6066,58,6064,35,97,6068,6072,58,6070,35,110,6074,6078,58,6076,35,99,6080,75,58,6082,35,101,6086,6100,836,6088,6090,6094,58,6092,35,111,6096,75,58,6098,35,102,6102,6134,836,6104,6106,6110,58,6108,35,119,6112,6116,58,6114,35,104,6118,6122,58,6120,35,101,6124,6128,58,6126,35,114,6130,75,58,6132,35,101,6136,6150,836,6138,6140,6144,58,6142,35,105,6146,75,58,6148,35,102,6152,6178,836,6154,6156,6160,58,6158,35,116,6162,6166,58,6164,35,104,6168,6172,58,6170,35,101,6174,75,58,6176,35,110,6180,75,836,6182,6184,6188,58,6186,35,101,6190,6194,58,6192,35,108,6196,6200,58,6198,35,115,6202,75,58,6204,35,101,1612,6208,1060,874,5418,6212,6214,5776,5374,6216,5492,6218,35,58,5616,6222,6224,6210,6226,6232,6228,836,6230,5208,848,5364,5492,6234,35,58,5616,6238,6240,6316,5628,6242,6244,6246,66,1034,6248,6312,82,6250,6252,6260,836,6254,6256,75,58,6258,35,64,6262,6270,836,6264,6266,75,58,6268,35,61,6272,6280,836,6274,6276,75,58,6278,35,124,6282,6296,836,6284,6286,6290,58,6288,35,45,6292,75,58,6294,35,62,6298,75,836,6300,6302,6306,58,6304,35,61,6308,75,58,6310,35,62,1612,6314,1060,874,6318,6210,6320,5776,6322,836,6324,5208,848,5364,6328,6330,5374,5926,5672,6220,6334,6336,5374,5956,5672,6236,6340,6346,5374,6342,6344,6220,5374,6236,6348,6364,6350,6360,6352,6356,6354,5208,5498,5364,5624,6358,35,96,5624,6362,35,96,6366,5956,5374,5926,6370,6372,5374,6220,6374,5926,6376,6386,6378,6382,6380,5208,5498,5364,5624,6384,35,96,5624,6388,35,96,6392,6402,6394,6398,6396,5364,5400,5208,5492,6400,35,92,6404,6432,5374,6406,5350,6408,6410,6430,82,6412,6414,6418,58,6416,35,39,6420,6424,58,6422,35,34,6426,75,58,6428,35,92,1612,874,6434,6442,6436,6438,814,5364,75,6440,35,10,5492,6444,35,110,6448,6452,66,6450,5374,6390,6454,6456,66,5350,1042,874,6460,6504,6462,6464,814,5364,6466,6468,66,662,6470,6502,1582,6472,6474,6480,66,6476,82,6478,35,48,6482,6486,66,6484,66,134,6488,6490,82,73,6492,6494,66,66,6496,6498,66,136,132,6500,35,10,35,0,5616,6506,5440,5752,6510,6514,6512,648,814,5364,6516,6532,6518,6528,6520,6524,6522,5208,5498,5364,5492,6526,35,39,5624,6530,35,39,6446,6534,35,39,6538,6554,6540,6550,6542,6546,6544,5208,5498,5364,5492,6548,35,34,5624,6552,35,34,5418,6556,6446,6558,35,34,6562,6566,6564,560,814,5364,6568,6458,5374,6570,6572,6508,5374,6574,6576,6536,6578,636,814,5364,6582,6600,66,6584,6586,6596,6588,6592,6590,5208,5498,5364,5624,6594,35,91,5624,6598,35,93,6602,5476,82,6604,5624,6606,35,44,6610,6612,66,67,6614,800,66,6616,66,5628,6620,6622,66,5616,6624,6628,6608,6626,1060,874,6630,5898,5374,6632,5440,6634,6636,5776,5374,6638,5492,6640,35,95,6644,6666,5374,6646,6648,6650,5374,5926,5672,6652,6654,6656,5374,6220,6658,6662,6660,1660,814,5364,5624,6664,35,44,6668,6682,6670,6672,808,5208,6674,6678,6676,836,814,5364,5624,6680,35,91,6684,6688,6686,1660,814,5364,5624,6690,35,93,6694,6846,83,6696,6698,6700,66,5374,6702,6792,83,6704,6706,6708,66,5374,6710,6718,82,6712,6714,6560,6716,624,814,5364,6720,6722,66,5374,6724,6736,82,6726,6728,6642,6730,6732,814,5364,6734,75,67,590,6738,6740,66,5374,6742,6754,66,6744,6746,6748,808,5208,6750,6332,6752,606,814,5364,6756,6762,82,6758,6760,75,812,5208,6764,6766,66,5374,6768,6784,66,6770,6772,6776,6774,5364,5400,5208,6618,6778,6780,75,58,6782,35,64,6786,6692,66,6788,6790,784,814,5364,6794,6580,66,6796,6798,6800,814,5364,6802,6830,1250,6804,6806,6818,66,6808,66,6810,590,6812,6814,75,58,6816,35,58,6820,6826,82,6822,6824,836,82,75,6828,836,66,66,6832,75,590,6834,6836,6840,58,6838,35,91,6842,75,58,6844,35,93,6848,6850,66,5672,6852,6864,83,6854,6856,6860,66,6858,808,5208,6862,84,814,5364,6866,6872,82,6868,6870,73,812,5208,6874,6876,66,5374,6878,6890,66,6880,6882,6886,6884,5364,5400,5208,5624,6888,35,44,6892,6894,814,5364,6896,6908,66,6898,66,6900,590,6902,6904,75,58,6906,35,44,6910,6914,66,6912,67,836,6916,836,82,75,6920,6938,5374,6922,6924,6934,6926,6928,808,5208,6930,6642,6932,590,814,5364,5418,6936,6692,6918,6940,6952,6942,6944,808,5208,6946,6950,6948,84,814,5364,6692,6918,6954,6992,5374,6956,6958,6990,6960,6962,808,5208,6964,6368,6966,6968,814,5364,6970,6982,82,6972,6974,6978,66,6976,67,836,6980,836,82,75,6984,6986,66,66,6988,590,66,66,6692,6918,6994,73,812,5208,6692,6918,7000,7020,83,7002,7004,7006,66,83,7008,7012,66,7010,66,5374,7014,6618,66,7016,7018,5364,5400,5208,7022,7066,66,7024,66,7026,7028,7030,814,5364,7032,7034,1250,73,532,7036,7038,7042,58,7040,35,106,7044,7048,58,7046,35,111,7050,7054,58,7052,35,105,7056,7060,58,7058,35,110,7062,75,58,7064,35,35,7068,7072,66,7070,66,5440,7074,7252,66,7076,83,7078,7080,7084,66,7082,808,5208,7086,7242,66,7088,7090,7092,814,5364,7094,7216,83,7096,7098,7100,66,83,7102,7106,66,7104,82,75,7108,7112,66,7110,66,83,7114,7118,66,7116,82,75,7120,7124,66,7122,66,83,7126,7134,66,7128,82,7130,7132,75,66,75,7136,7140,66,7138,66,83,7142,7150,66,7144,82,7146,7148,75,66,75,7152,7156,66,7154,66,83,7158,7200,82,7160,7162,7164,66,67,7166,75,66,7168,67,7170,7172,7176,800,7174,1060,874,7178,7182,58,7180,35,84,7184,7188,58,7186,35,114,7190,7194,58,7192,35,117,7196,75,58,7198,35,101,7202,7204,66,66,7206,7208,66,83,7210,7212,82,75,7214,73,66,66,7218,7222,66,7220,66,492,7224,7226,66,492,492,7228,532,7230,7232,7236,58,7234,35,105,7238,75,58,7240,35,102,7244,7248,7246,5364,5400,5208,5624,7250,35,124,7254,6618,66,7256,7258,5364,5400,5208,7262,7280,66,7264,7266,7276,7268,7272,7270,5208,5498,5364,5624,7274,35,123,5624,7278,35,125,7282,5476,82,7284,5624,7286,35,59,7290,7324,82,7292,532,7294,7296,7300,58,7298,35,102,7302,7306,58,7304,35,97,7308,7312,58,7310,35,105,7314,7318,58,7316,35,108,7320,75,58,7322,35,35,7326,7328,66,492,454,7330,7332,7336,58,7334,35,106,7338,7342,58,7340,35,111,7344,7348,58,7346,35,105,7350,7354,58,7352,35,110,7356,75,58,7358,35,35,7362,7372,66,7364,7366,7368,814,5364,7370,432,66,7288,7374,7376,66,7260,7378,7398,66,7380,7382,7384,808,5208,7386,6918,7388,7390,814,5364,7392,7394,66,832,7396,836,82,75,6998,7400,7402,7406,58,7404,35,45,7408,75,58,7410,35,62,7414,7360,83,7416,7418,7422,66,7420,808,5208,7424,7432,66,7426,7428,7430,814,5364,67,492,7434,7466,7436,7440,7438,5208,5498,5364,6618,7442,7444,7448,58,7446,35,99,7450,7454,58,7452,35,97,7456,7460,58,7458,35,115,7462,75,58,7464,35,101,6618,7468,7470,7474,58,7472,35,111,7476,75,58,7478,35,102,7482,7360,66,7484,7486,7490,7488,5364,5400,5208,6618,7492,7494,7498,58,7496,35,99,7500,7504,58,7502,35,97,7506,7510,58,7508,35,115,7512,75,58,7514,35,101,7518,7522,66,7520,66,432,7524,7528,66,7526,82,75,7530,832,66,7532,66,836,7536,7548,66,7538,7540,7544,7542,5364,5400,5208,5624,7546,35,92,7550,7556,83,7552,7554,7480,66,5374,7558,7564,66,7560,7562,7288,814,5364,7566,7578,66,7568,7570,7576,7572,7516,7574,5208,848,5364,5440,6996,7580,7584,7582,5364,5400,5208,6618,7586,7588,7592,58,7590,35,45,7594,75,58,7596,35,62,67,7600,7602,7604,66,492,492,7606,532,7608,7610,75,58,7612,35,44,7616,7628,66,7618,7620,7624,7622,5364,5400,5208,5624,7626,35,44,7630,7646,82,7632,7634,7636,812,5208,492,7638,532,7640,7642,75,58,7644,35,44,7648,7650,66,5374,7652,7598,814,5364,7656,7668,83,7658,7660,7664,66,7662,808,5208,7666,84,814,5364,7670,7676,82,7672,7674,73,812,5208,7678,7680,66,5374,7682,7614,66,7684,5374,7686,7688,6338,7690,7692,814,5364,7694,532,66,492,7698,7700,808,5208,7702,7740,7704,7706,814,5364,7708,7720,66,7710,66,7712,454,7714,7716,75,58,7718,35,64,7722,7724,66,492,7726,7736,82,7728,532,7730,7732,75,58,7734,35,64,7738,532,66,492,7742,7744,5374,6338,7746,7750,7748,1660,814,5364,5624,7752,35,44,7756,7768,66,7758,7760,7764,7762,5364,5400,5208,5624,7766,35,40,7770,7802,82,7772,7774,7784,7776,7780,7778,5364,5400,5208,5624,7782,35,41,7786,7788,812,5208,532,7790,7792,7796,58,7794,35,40,7798,75,58,7800,35,41,7804,7806,66,5374,7808,7830,83,7810,7812,7814,66,5374,7816,7822,82,7818,5624,7820,35,41,7824,7654,66,7826,7828,5364,5410,5208,7832,7838,82,7834,5624,7836,35,41,7840,7696,66,7842,7844,5364,5410,5208,7848,7898,83,7850,7852,7854,66,67,7856,7866,66,7858,67,7860,7862,73,82,7864,75,846,7868,7892,83,7870,7872,7874,66,67,7876,7880,66,7878,66,66,7882,7886,66,7884,66,1050,67,7888,800,7890,1060,874,7894,7846,66,7896,1202,846,7900,7902,66,75,7904,7846,66,1746,7908,7914,66,7910,82,7912,75,144,7916,8000,83,7918,7920,7922,66,67,7924,7976,83,7926,7928,7930,66,67,7932,7956,83,7934,7936,7938,66,67,7940,7950,66,7942,67,7944,7946,73,82,7948,75,846,67,7952,800,7954,1060,874,7958,7906,83,7960,7962,7964,66,67,7966,7970,66,7968,66,66,7972,7906,66,7974,66,1050,7978,7906,83,7980,7982,7984,66,67,7986,7990,66,7988,66,66,7992,7996,66,7994,66,1054,1042,7998,1060,874,8002,8004,66,1746,8006,8008,66,84,8010,7906,83,8012,8014,8016,66,67,8018,8022,66,8020,66,66,8024,8028,66,8026,66,1054,8030,8034,66,8032,66,1034,8036,7846,66,1746,8040,8046,66,8042,66,8044,82,144,8048,8054,66,8050,66,8052,82,75,8056,8062,66,8058,66,8060,66,83,8064,8070,66,8066,66,8068,82,75,8072,8078,66,8074,66,8076,66,66,8080,8180,83,8082,8084,8086,66,83,8088,8092,66,8090,66,83,8094,8150,83,8096,8098,8100,66,83,8102,8106,66,8104,66,67,8108,8118,66,8110,66,8112,83,8114,8116,75,83,73,8120,8124,66,8122,82,73,8126,8130,66,8128,66,83,8132,8138,66,8134,66,8136,66,67,8140,8142,66,66,8144,8146,66,67,800,8148,1060,874,8152,8038,83,8154,8156,8158,66,83,8160,8164,66,8162,66,67,8166,8172,66,8168,66,8170,66,66,8174,8038,66,8176,66,8178,66,492,8182,8214,83,8184,8186,8188,66,66,8190,8192,66,67,8194,8198,66,8196,66,83,8200,8206,66,8202,66,8204,66,66,8208,8210,66,67,800,8212,1060,874,8216,8038,66,8218,66,8220,67,8222,8224,454,66,66,8228,8230,82,75,8232,8038,66,66,8236,8238,82,73,8240,8242,66,83,8244,8250,83,8246,8248,7906,66,83,8252,454,66,8254,66,8256,492,8258,3692,8260,35,89,8264,8276,66,8266,67,8268,8270,8272,66,66,8274,832,66,66,8278,8282,66,8280,66,7516,8284,8290,82,8286,8288,836,82,75,8292,836,66,66,8296,8304,66,8298,67,8300,8302,73,82,75,8306,8314,66,8308,83,8310,8312,73,66,66,8316,8344,66,8318,83,8320,8322,8324,66,83,8326,8330,66,8328,66,66,8332,8336,66,8334,66,66,8338,8340,66,84,8342,836,82,75,8346,8362,66,8348,66,8350,66,8352,66,8354,66,8356,67,8358,8360,73,66,66,8364,8712,83,8366,8368,8370,66,66,8372,8374,66,66,8376,8378,66,67,8380,8384,66,8382,66,67,8386,8392,66,8388,66,8390,66,67,8394,8402,66,8396,66,8398,66,8400,66,67,8404,8414,66,8406,66,8408,66,8410,66,8412,66,67,8416,8448,83,8418,8420,8422,66,83,8424,8428,66,8426,66,66,8430,8434,66,8432,66,66,8436,8440,66,8438,66,67,8442,800,66,8444,66,8446,66,66,8450,8696,82,8452,8454,8458,66,8456,66,67,8460,8466,66,8462,66,8464,66,836,8468,8688,82,8470,8472,8550,66,8474,82,8476,1448,8478,8480,8484,58,8482,35,98,8486,8490,58,8488,35,97,8492,8496,58,8494,35,100,8498,8502,58,8500,35,32,8504,8508,58,8506,35,109,8510,8514,58,8512,35,117,8516,8520,58,8518,35,108,8522,8526,58,8524,35,116,8528,8532,58,8530,35,105,8534,8538,58,8536,35,100,8540,8544,58,8542,35,101,8546,75,58,8548,35,102,8552,8556,66,8554,82,75,8558,8562,66,8560,66,83,8564,8640,82,8566,8568,8570,66,67,8572,8576,66,8574,82,75,8578,8582,66,8580,66,83,8584,8592,82,8586,8588,1652,66,8590,66,432,8594,8596,66,66,8598,8600,66,67,8602,8608,82,8604,8606,75,66,75,8610,8612,66,83,8614,8620,82,8616,8618,75,66,75,8622,8624,66,83,8626,8628,82,75,8630,8632,66,83,8634,8636,82,75,8638,73,66,66,8642,8644,66,66,8646,8648,66,83,8650,8656,82,8652,8654,75,66,75,8658,8660,66,83,8662,8668,82,8664,8666,75,66,75,8670,8672,66,83,8674,8676,82,75,8678,8680,66,83,8682,8684,82,75,8686,73,66,66,8690,8692,66,66,8694,832,66,66,8698,8700,66,66,8702,8704,66,66,8706,8708,66,66,8710,8294,66,66,8714,8294,66,8716,67,8718,8720,836,66,66,8724,8764,83,8726,8728,8730,66,5374,8732,8756,66,8734,8736,8738,808,5208,8740,6996,8742,8744,808,5208,8746,6236,8748,8750,808,5208,8752,6996,8754,8262,814,5364,6998,8758,8760,75,58,8762,35,61,8766,8776,66,8768,8770,6332,8772,832,8774,5208,848,5364,8778,8790,66,8780,8782,8788,8784,7516,8786,5208,848,5364,5418,6996,6998,8792,8794,75,58,8796,35,61,67,8800,1250,8802,8804,8836,82,8806,8808,8818,82,8810,8812,8814,82,7288,8816,8234,66,66,8820,8822,66,83,8824,8828,66,8826,66,66,8830,8834,66,8832,66,492,67,454,8838,73,66,66,8842,73,83,8844,8846,8850,66,8848,808,5208,8852,8858,66,8854,8856,8798,814,5364,8860,8904,66,8862,8864,8890,8866,8870,8868,5208,5498,5364,6618,8872,8874,8878,58,8876,35,108,8880,8884,58,8882,35,101,8886,75,58,8888,35,116,6618,8892,8894,8898,58,8896,35,105,8900,75,58,8902,35,110,8906,8916,66,8908,8910,8912,814,5364,8294,8914,1060,874,8918,8722,66,7260,8922,9026,83,8924,8926,8930,66,8928,808,5208,8932,8994,83,8934,8936,8940,66,8938,808,5208,8942,8974,66,8944,8946,8948,814,5364,8950,8954,66,8952,66,492,8956,8958,66,492,492,8960,532,8962,8964,8968,58,8966,35,105,8970,75,58,8972,35,102,8976,8980,8978,5364,5400,5208,6618,8982,8984,8988,58,8986,35,105,8990,75,58,8992,35,102,8996,9000,8998,5364,5400,5208,6618,9002,9004,9008,58,9006,35,116,9010,9014,58,9012,35,104,9016,9020,58,9018,35,101,9022,75,58,9024,35,110,9028,9032,9030,5364,5400,5208,6618,9034,9036,9040,58,9038,35,101,9042,9046,58,9044,35,108,9048,9052,58,9050,35,115,9054,75,58,9056,35,101,9060,9076,1250,9062,9064,9066,66,492,492,9068,532,9070,9072,75,58,9074,35,58,532,9078,9080,9084,58,9082,35,91,9086,75,58,9088,35,93,5350,9092,75,75,9096,9126,5374,9098,9100,9122,9102,9106,9104,5364,5400,5208,9108,9118,9110,9114,9112,5364,5400,5208,5492,9116,35,124,5492,9120,35,93,9124,75,812,5208,9128,9094,9130,9132,808,5208,9134,9090,9136,836,814,5364,5616,9140,9142,9176,9144,9148,9146,5364,5400,5208,9150,9172,9152,9156,9154,5364,5400,5208,9158,9168,9160,9164,9162,5364,5400,5208,5492,9166,35,91,5492,9170,35,114,5492,9174,35,124,9178,9094,9180,9182,814,5364,9184,636,66,560,9188,9190,82,6560,9192,9194,66,5374,9196,9208,82,9198,9200,9204,9202,532,814,5364,9206,6332,5374,6326,9210,9212,66,5374,9214,9242,82,9216,9218,9230,9220,9224,9222,5364,5400,5208,5672,9226,5624,9228,35,44,9232,9234,812,5208,532,9236,9238,75,58,9240,35,44,9244,9246,66,5374,9248,7534,83,9250,9252,9254,66,5374,9256,7412,83,9258,9260,9262,66,5374,9264,7754,83,9266,9268,9270,66,5374,9272,9294,83,9274,9276,9278,66,5374,9280,9282,82,9138,9284,9286,66,5374,9288,8840,83,9290,9292,8920,66,5374,9296,6580,66,9298,9300,9058,814,5364,9304,9312,66,9306,9308,9310,814,5364,1602,492,9314,9186,66,5440,9318,9316,83,73,84,9322,9324,9328,66,9326,82,846,9330,9346,82,9332,9334,9338,66,9336,82,75,9340,9342,82,73,9344,73,66,83,9348,9350,66,83,9352,9356,66,9354,66,83,9358,9374,82,9360,9362,9364,82,73,9366,9368,66,83,9370,73,66,9372,82,75,9376,9378,66,83,9380,9384,66,9382,66,83,9386,9400,82,9388,9390,9392,82,73,9394,9396,66,83,9398,73,82,75,9402,9404,66,66,9406,73,66,66,9410,9416,66,9412,66,9414,82,1008,9418,1682,66,9420,66,9422,82,9424,35,9,9428,9434,66,9430,66,9432,82,1012,9436,1682,66,9438,66,9440,82,354,9444,9448,66,9446,82,6338,9450,9454,66,9452,66,5628,9456,9466,66,9458,67,9460,9462,9464,66,66,800,874,67,9468,9408,9470,1060,874,9474,9482,66,9476,83,9478,9480,84,66,83,9484,9496,66,9486,66,9488,66,9490,66,9492,82,9494,75,1476,9498,9566,83,9500,9502,9504,66,66,9506,9508,66,66,9510,9512,66,83,9514,9518,66,9516,66,83,9520,9524,66,9522,66,1636,9526,9556,83,9528,9530,9532,66,67,9534,9538,66,9536,66,66,9540,9546,66,9542,66,9544,1042,9320,67,9548,9550,1008,66,9552,9426,9554,1060,874,67,9558,9560,1008,66,9562,9426,9564,1060,874,9568,9604,82,9570,67,9572,9574,73,1250,9576,9578,9600,82,9580,67,9582,9584,9586,66,66,9588,9590,66,67,9592,9596,66,9594,66,492,9598,532,66,492,9602,73,66,66,9606,9608,66,83,9610,9614,66,9612,66,83,9616,9622,66,9618,66,9620,66,67,9624,9632,66,9626,66,9628,66,9630,66,67,9634,9654,82,9636,1582,9638,9640,9642,66,84,9644,9648,66,9646,66,492,67,9650,9652,532,66,492,9656,9658,66,83,9660,9664,66,9662,66,66,9666,9670,66,9668,66,67,9672,9678,66,9674,66,9676,66,67,9680,9716,82,9682,9684,9694,66,9686,66,9688,82,9690,75,9692,75,1476,9696,9700,66,9698,66,84,9702,9704,66,84,9706,9710,66,9708,66,492,67,9712,9714,532,66,492,9718,9720,66,66,9722,9724,66,83,9726,9730,66,9728,66,66,67,9732,9734,1008,66,9736,9426,9738,1060,874,9742,9744,66,9316,9746,9756,82,9748,9750,9752,66,9302,84,9754,35,0,9758,9760,66,83,9762,9766,66,9764,66,67,9768,9782,66,9770,66,9772,83,9774,9776,9780,82,9778,35,9,798,878,9784,9824,83,9786,9788,9790,66,83,9792,9796,66,9794,66,83,9798,9808,82,9800,9802,9804,82,148,9806,73,66,66,9810,9812,66,66,9814,9816,66,66,9818,9472,66,9820,9822,5208,848,5364,9826,9832,66,9828,66,9830,66,5418,9834,9844,82,9836,9838,9840,82,148,9842,73,66,66,9846,9848,66,66,9850,9852,66,83,9854,9442,66,9856,66,9858,9860,832,9862,5208,848,5364,9866,5440,66,9868,9870,9872,814,5364,1602,696,9876,9884,66,9878,9880,9882,814,5364,1532,3670,9886,9904,82,9888,5616,9890,6618,9892,9894,9898,58,9896,35,45,9900,75,58,9902,35,62,9906,9864,66,5476,9910,5926,9912,9914,814,5364,9916,722,83,9918,9920,9966,82,9922,9924,9940,696,9926,722,9928,9930,9934,58,9932,35,91,9936,75,58,9938,35,93,722,9942,9944,9948,58,9946,35,67,9950,9954,58,9952,35,104,9956,9960,58,9958,35,97,9962,75,58,9964,35,114,9968,10006,82,9970,9972,9976,58,9974,35,83,9978,9982,58,9980,35,116,9984,9988,58,9986,35,114,9990,9994,58,9992,35,105,9996,10000,58,9998,35,110,10002,75,58,10004,35,103,800,10008,1060,874,10012,10144,5374,10014,10016,10138,5374,10018,10020,9908,5374,10022,10024,10034,10026,10030,10028,5364,5400,5208,5624,10032,35,40,10036,10068,5374,10038,10040,10050,10042,10046,10044,5364,5400,5208,5624,10048,35,41,10052,10054,812,5208,722,10056,10058,10062,58,10060,35,40,10064,75,58,10066,35,41,10070,10134,10072,10076,10074,5364,5410,5208,10078,10090,10080,10082,808,5208,10084,10088,10086,84,814,5364,9874,10010,10092,10130,5374,10094,10096,10106,10098,10102,10100,5364,5400,5208,5624,10104,35,44,10108,10128,10110,10112,814,5364,67,10114,10116,10118,66,696,696,10120,722,10122,10124,75,58,10126,35,44,9874,10010,10132,73,812,5208,5624,10136,35,41,10140,5956,10142,712,814,5364,10146,10156,10148,10152,10150,5364,5400,5208,5624,10154,35,91,10158,10190,5374,10160,10162,10172,10164,10168,10166,5364,5400,5208,5624,10170,35,93,10174,10176,812,5208,722,10178,10180,10184,58,10182,35,91,10186,75,58,10188,35,93,10192,10212,10194,10196,814,5364,696,10198,722,10200,10202,10206,58,10204,35,91,10208,75,58,10210,35,93,10214,10222,10216,10220,10218,5364,5410,5208,9874,10010,5624,10224,35,93,10228,10232,82,10230,1664,712,10234,10236,66,66,10238,722,66,10240,1582,696,10244,10286,5374,10246,10248,10010,10250,10252,808,5208,10254,6220,10256,10258,808,5208,10260,10010,10262,10264,814,5364,10266,10274,66,10268,67,10270,10272,408,66,66,10276,10282,82,10278,10280,836,82,75,10284,836,66,66,10288,10298,10290,10292,808,5208,10294,5926,10296,408,814,5364,5418,10010,10302,10366,10304,10306,808,5208,10308,10312,10310,4434,814,5364,10314,10352,10316,10348,10318,10322,10320,5208,5498,5364,6618,10324,10326,10330,58,10328,35,100,10332,10336,58,10334,35,97,10338,10342,58,10340,35,116,10344,75,58,10346,35,97,5624,10350,35,61,10354,10364,10356,10358,808,5208,10360,5926,10362,10226,814,5364,5418,5956,10368,10370,5476,10242,5624,10372,35,124,10376,10390,10378,10380,814,5364,10382,10386,82,10384,35,48,10388,73,66,134,5616,5752,10394,10398,66,10396,66,1664,10400,10406,66,10402,66,10404,67,832,67,832,10410,10440,82,10412,10414,10424,82,10416,10418,10420,5476,6338,5624,10422,35,44,10426,10430,66,10428,808,5208,10432,10434,82,10374,10436,10392,66,10438,814,5364,10442,10444,66,66,10446,10452,82,10448,5624,10450,35,59,10454,6618,66,10456,10458,5208,5498,5364,10462,10542,5374,10464,10466,10502,5374,10468,10470,356,10408,10472,10474,10478,58,10476,35,105,10480,10484,58,10482,35,110,10486,10490,58,10488,35,102,10492,10496,58,10494,35,105,10498,75,58,10500,35,120,10504,354,10408,10506,10508,10512,58,10510,35,105,10514,10518,58,10516,35,110,10520,10524,58,10522,35,102,10526,10530,58,10528,35,105,10532,10536,58,10534,35,120,10538,75,58,10540,35,108,10544,350,10408,10546,10548,10552,58,10550,35,105,10554,10558,58,10556,35,110,10560,10564,58,10562,35,102,10566,10570,58,10568,35,105,10572,10576,58,10574,35,120,10578,75,58,10580,35,114,10584,10594,10586,10588,808,5208,10590,6332,10592,832,814,5364,10596,10618,10598,10602,10600,5364,5400,5208,10604,10614,10606,10610,10608,5364,5400,5208,5492,10612,35,58,5624,10616,35,58,9874,10010,10622,10660,10624,10628,10626,5364,5400,5208,6618,10630,10632,10636,58,10634,35,99,10638,10642,58,10640,35,108,10644,10648,58,10646,35,97,10650,10654,58,10652,35,115,10656,75,58,10658,35,115,10662,10684,10664,10666,808,5208,10668,10678,10670,10672,808,5208,10674,5926,10676,4508,814,5364,10680,5956,10682,712,814,5364,10686,10724,10688,10692,10690,5364,5400,5208,6618,10694,10696,10700,58,10698,35,119,10702,10706,58,10704,35,104,10708,10712,58,10710,35,101,10714,10718,58,10716,35,114,10720,75,58,10722,35,101,7260,10582,9874,10010,10730,10788,66,10732,10734,10738,10736,5364,5400,5208,6618,10740,10742,10746,58,10744,35,105,10748,10752,58,10750,35,110,10754,10758,58,10756,35,115,10760,10764,58,10762,35,116,10766,10770,58,10768,35,97,10772,10776,58,10774,35,110,10778,10782,58,10780,35,99,10784,75,58,10786,35,101,10790,10872,66,10792,10794,10796,808,5208,10798,10726,10800,10802,808,5208,10804,5926,10806,10808,808,5208,10810,10824,10812,10814,814,5364,10816,400,66,10818,67,10820,10822,4854,66,66,10826,10868,5374,10828,10830,10846,10832,10834,808,5208,10836,5926,10838,10840,814,5364,10842,404,66,10844,66,1660,10848,10854,10850,10726,10852,5364,5410,5208,6618,10856,10858,10862,58,10860,35,61,10864,75,58,10866,35,62,10870,75,812,5208,10874,10914,66,10876,10878,10882,10880,5364,5400,5208,6618,10884,10886,10890,58,10888,35,119,10892,10896,58,10894,35,104,10898,10902,58,10900,35,101,10904,10908,58,10906,35,114,10910,75,58,10912,35,101,10916,10926,66,10918,10920,10922,814,5364,8294,10924,1060,874,10928,8722,66,7260,10932,10948,82,10934,10936,10942,5374,10938,5624,10940,35,59,10944,10946,812,5208,35,59,10950,10956,66,10952,10954,5364,5410,5208,10958,10964,82,10960,5624,10962,35,59,10966,10968,66,5476,10970,11224,83,10972,10974,10976,66,5374,10978,11200,82,10980,10982,11032,10984,10988,10986,5364,5400,5208,6618,10990,10992,10996,58,10994,35,102,10998,11002,58,11000,35,111,11004,11008,58,11006,35,114,11010,11014,58,11012,35,101,11016,11020,58,11018,35,105,11022,11026,58,11024,35,103,11028,75,58,11030,35,110,11034,11134,5374,11036,11038,11090,11040,11044,11042,5364,5400,5208,11046,6332,11048,11052,11050,5364,5400,5208,6618,11054,11056,11060,58,11058,35,105,11062,11066,58,11064,35,109,11068,11072,58,11070,35,112,11074,11078,58,11076,35,111,11080,11084,58,11082,35,114,11086,75,58,11088,35,116,11092,11108,11094,11096,808,5208,11098,6332,11100,11102,808,5208,11104,6536,11106,4944,814,5364,11110,11132,11112,11116,11114,5364,5400,5208,11118,11128,11120,11124,11122,5364,5400,5208,5492,11126,35,58,5624,11130,35,58,9874,10010,11136,11188,11138,11142,11140,5364,5400,5208,11144,6332,11146,11150,11148,5364,5400,5208,6618,11152,11154,11158,58,11156,35,101,11160,11164,58,11162,35,120,11166,11170,58,11168,35,112,11172,11176,58,11174,35,111,11178,11182,58,11180,35,114,11184,75,58,11186,35,116,11190,6332,11192,11194,808,5208,11196,6536,11198,5140,814,5364,11202,11204,66,5374,11206,11214,66,11208,5374,11210,11212,10620,5374,10300,11216,11218,66,10728,11220,9740,82,11222,35,0,11226,11240,66,11228,11230,11232,814,5364,11234,11236,66,5120,8294,11238,1060,874,11242,11248,82,11244,5624,11246,35,59,11250,11252,66,5450,11254,11256,66,8722,11258,9740,82,11260,35,0,5200,11264,11266,10930,11268,11270,802,5284,11272,11278,11274,5578,11276,5364,5400,5208,11280,11306,11282,11284,814,5364,11286,1656,66,11288,836,11290,11292,11300,832,11294,11296,75,58,11298,35,58,11302,350,832,11304,35,5,5418,10460,11310,11350,836,11312,11314,11330,4434,11316,722,11318,11320,11324,58,11322,35,40,11326,75,58,11328,35,41,11332,75,836,11334,11336,75,408,11338,11340,11344,58,11342,35,40,11346,75,58,11348,35,41,11352,11454,836,11354,11356,11384,4434,11358,722,11360,11362,11366,58,11364,35,66,11368,11372,58,11370,35,111,11374,11378,58,11376,35,111,11380,75,58,11382,35,108,11386,11416,836,11388,11390,75,408,11392,11394,11398,58,11396,35,84,11400,11404,58,11402,35,114,11406,11410,58,11408,35,117,11412,75,58,11414,35,101,11418,75,836,11420,11422,75,408,11424,11426,11430,58,11428,35,70,11432,11436,58,11434,35,97,11438,11442,58,11440,35,108,11444,11448,58,11446,35,115,11450,75,58,11452,35,101,11456,11564,836,11458,11460,11488,4434,11462,11464,11480,696,11466,722,11468,11470,11474,58,11472,35,91,11476,75,58,11478,35,93,712,11482,11484,75,58,11486,35,97,11490,11508,836,11492,11494,75,408,11496,11498,11502,58,11500,35,91,11504,75,58,11506,35,93,11510,75,836,11512,11514,11522,408,11516,11518,75,58,11520,35,58,11524,11534,836,11526,712,11528,11530,75,58,11532,35,97,11536,75,836,11538,11540,11556,696,11542,722,11544,11546,11550,58,11548,35,91,11552,75,58,11554,35,93,712,11558,11560,75,58,11562,35,97,11566,75,836,11568,11570,11604,4434,11572,11574,11596,696,11576,11578,11588,696,11580,722,11582,11584,75,58,11586,35,44,712,11590,11592,75,58,11594,35,97,712,11598,11600,75,58,11602,35,98,11606,75,836,11608,11610,11618,408,11612,11614,75,58,11616,35,44,11620,11630,836,11622,712,11624,11626,75,58,11628,35,97,11632,75,836,11634,712,11636,11638,75,58,11640,35,98,11644,13596,11646,11658,82,11648,11650,3692,66,11652,492,11654,3692,11656,35,81,11660,11670,66,11662,66,11664,1664,11666,1024,11668,1018,3690,11672,13512,83,11674,11676,11678,66,83,11680,11684,66,11682,66,1652,11686,11814,66,11688,83,11690,11692,11694,66,836,11696,11730,66,11698,832,11700,11702,11706,58,11704,35,105,11708,11712,58,11710,35,110,11714,11718,58,11716,35,116,11720,11724,58,11722,35,69,11726,75,58,11728,35,113,11732,11810,66,11734,832,11736,11738,11760,3670,11740,722,11742,11744,11748,58,11746,35,73,11750,11754,58,11752,35,110,11756,75,58,11758,35,116,11762,11784,3670,11764,722,11766,11768,11772,58,11770,35,73,11774,11778,58,11776,35,110,11780,75,58,11782,35,116,722,11786,11788,11792,58,11790,35,66,11794,11798,58,11796,35,111,11800,11804,58,11802,35,111,11806,75,58,11808,35,108,84,11812,35,61,11816,11944,66,11818,83,11820,11822,11824,66,836,11826,11860,66,11828,832,11830,11832,11836,58,11834,35,105,11838,11842,58,11840,35,110,11844,11848,58,11846,35,116,11850,11854,58,11852,35,76,11856,75,58,11858,35,69,11862,11940,66,11864,832,11866,11868,11890,3670,11870,722,11872,11874,11878,58,11876,35,73,11880,11884,58,11882,35,110,11886,75,58,11888,35,116,11892,11914,3670,11894,722,11896,11898,11902,58,11900,35,73,11904,11908,58,11906,35,110,11910,75,58,11912,35,116,722,11916,11918,11922,58,11920,35,66,11924,11928,58,11926,35,111,11930,11934,58,11932,35,111,11936,75,58,11938,35,108,84,11942,35,76,11946,12092,66,11948,83,11950,11952,11954,66,836,11956,11996,66,11958,832,11960,11962,11966,58,11964,35,99,11968,11972,58,11970,35,104,11974,11978,58,11976,35,97,11980,11984,58,11982,35,114,11986,11990,58,11988,35,69,11992,75,58,11994,35,113,11998,12088,66,12000,832,12002,12004,12032,3670,12006,722,12008,12010,12014,58,12012,35,67,12016,12020,58,12018,35,104,12022,12026,58,12024,35,97,12028,75,58,12030,35,114,12034,12062,3670,12036,722,12038,12040,12044,58,12042,35,67,12046,12050,58,12048,35,104,12052,12056,58,12054,35,97,12058,75,58,12060,35,114,722,12064,12066,12070,58,12068,35,66,12072,12076,58,12074,35,111,12078,12082,58,12080,35,111,12084,75,58,12086,35,108,84,12090,35,61,12094,12240,66,12096,67,12098,12100,12102,66,836,12104,12144,66,12106,832,12108,12110,12114,58,12112,35,99,12116,12120,58,12118,35,104,12122,12126,58,12124,35,97,12128,12132,58,12130,35,114,12134,12138,58,12136,35,76,12140,75,58,12142,35,69,12146,12236,66,12148,832,12150,12152,12180,3670,12154,722,12156,12158,12162,58,12160,35,67,12164,12168,58,12166,35,104,12170,12174,58,12172,35,97,12176,75,58,12178,35,114,12182,12210,3670,12184,722,12186,12188,12192,58,12190,35,67,12194,12198,58,12196,35,104,12200,12204,58,12202,35,97,12206,75,58,12208,35,114,722,12212,12214,12218,58,12216,35,66,12220,12224,58,12222,35,111,12226,12230,58,12228,35,111,12232,75,58,12234,35,108,84,12238,35,76,12242,12332,66,12244,836,12246,12248,12262,832,12250,12252,12256,58,12254,35,105,12258,75,58,12260,35,102,12264,12328,832,12266,12268,12296,3670,12270,722,12272,12274,12278,58,12276,35,66,12280,12284,58,12282,35,111,12286,12290,58,12288,35,111,12292,75,58,12294,35,108,12298,12308,3670,12300,712,12302,12304,75,58,12306,35,97,12310,12320,3670,12312,712,12314,12316,75,58,12318,35,97,712,12322,12324,75,58,12326,35,97,3692,12330,35,73,12334,12418,66,12336,836,12338,12340,12360,832,12342,12344,12348,58,12346,35,99,12350,12354,58,12352,35,104,12356,75,58,12358,35,114,12362,12414,832,12364,12366,12388,3670,12368,722,12370,12372,12376,58,12374,35,73,12378,12382,58,12380,35,110,12384,75,58,12386,35,116,722,12390,12392,12396,58,12394,35,67,12398,12402,58,12400,35,104,12404,12408,58,12406,35,97,12410,75,58,12412,35,114,3692,12416,35,73,12420,12504,66,12422,836,12424,12426,12446,832,12428,12430,12434,58,12432,35,111,12436,12440,58,12438,35,114,12442,75,58,12444,35,100,12448,12500,832,12450,12452,12480,3670,12454,722,12456,12458,12462,58,12460,35,67,12464,12468,58,12466,35,104,12470,12474,58,12472,35,97,12476,75,58,12478,35,114,722,12482,12484,12488,58,12486,35,73,12490,12494,58,12492,35,110,12496,75,58,12498,35,116,3692,12502,35,73,12506,13452,82,12508,12510,12658,836,12512,12514,12552,832,12516,12518,12522,58,12520,35,105,12524,12528,58,12526,35,111,12530,12534,58,12532,35,66,12536,12540,58,12538,35,105,12542,12546,58,12544,35,110,12548,75,58,12550,35,100,12554,12654,832,12556,12558,12586,3670,12560,12562,12578,696,12564,722,12566,12568,12572,58,12570,35,73,12574,75,58,12576,35,79,712,12580,12582,75,58,12584,35,97,12588,12628,3670,12590,12592,12602,3670,12594,712,12596,12598,75,58,12600,35,97,12604,12620,696,12606,722,12608,12610,12614,58,12612,35,73,12616,75,58,12618,35,79,712,12622,12624,75,58,12626,35,98,12630,12646,696,12632,722,12634,12636,12640,58,12638,35,73,12642,75,58,12644,35,79,712,12648,12650,75,58,12652,35,98,3692,12656,35,67,12660,12748,836,12662,12664,12702,832,12666,12668,12672,58,12670,35,105,12674,12678,58,12676,35,111,12680,12684,58,12682,35,80,12686,12690,58,12688,35,117,12692,12696,58,12694,35,114,12698,75,58,12700,35,101,12704,12744,832,12706,12708,12718,3670,12710,712,12712,12714,75,58,12716,35,97,12720,12736,696,12722,722,12724,12726,12730,58,12728,35,73,12732,75,58,12734,35,79,712,12738,12740,75,58,12742,35,97,3692,12746,35,86,12750,12856,836,12752,12754,12822,832,12756,12758,12762,58,12760,35,101,12764,12768,58,12766,35,120,12770,12774,58,12772,35,105,12776,12780,58,12778,35,116,12782,12786,58,12784,35,83,12788,12792,58,12790,35,117,12794,12798,58,12796,35,99,12800,12804,58,12802,35,99,12806,12810,58,12808,35,101,12812,12816,58,12814,35,115,12818,75,58,12820,35,115,12824,12852,832,12826,12828,12844,696,12830,722,12832,12834,12838,58,12836,35,73,12840,75,58,12842,35,79,712,12846,12848,75,58,12850,35,97,3692,12854,35,46,12858,13024,836,12860,12862,12954,832,12864,12866,12870,58,12868,35,117,12872,12876,58,12874,35,110,12878,12882,58,12880,35,115,12884,12888,58,12886,35,97,12890,12894,58,12892,35,102,12896,12900,58,12898,35,101,12902,12906,58,12904,35,80,12908,12912,58,12910,35,101,12914,12918,58,12916,35,114,12920,12924,58,12922,35,102,12926,12930,58,12928,35,111,12932,12936,58,12934,35,114,12938,12942,58,12940,35,109,12944,12948,58,12946,35,73,12950,75,58,12952,35,79,12956,12996,832,12958,12960,12988,3670,12962,12964,12980,696,12966,722,12968,12970,12974,58,12972,35,73,12976,75,58,12978,35,79,712,12982,12984,75,58,12986,35,97,712,12990,12992,75,58,12994,35,97,12998,13020,492,13000,13002,13008,492,13004,3692,13006,35,67,13010,13016,492,13012,3692,13014,35,84,3692,13018,35,63,3692,13022,35,75,13026,13238,836,13028,13030,13062,832,13032,13034,13038,58,13036,35,106,13040,13044,58,13042,35,111,13046,13050,58,13048,35,105,13052,13056,58,13054,35,110,13058,75,58,13060,35,35,13064,13074,832,13066,712,13068,13070,75,58,13072,35,97,13076,13170,492,13078,532,13080,13082,13086,58,13084,35,117,13088,13092,58,13090,35,110,13094,13098,58,13096,35,115,13100,13104,58,13102,35,97,13106,13110,58,13108,35,102,13112,13116,58,13114,35,101,13118,13122,58,13120,35,80,13124,13128,58,13126,35,101,13130,13134,58,13132,35,114,13136,13140,58,13138,35,102,13142,13146,58,13144,35,111,13148,13152,58,13150,35,114,13154,13158,58,13156,35,109,13160,13164,58,13162,35,73,13166,75,58,13168,35,79,532,13172,13174,13178,58,13176,35,101,13180,13184,58,13182,35,120,13186,13190,58,13188,35,105,13192,13196,58,13194,35,116,13198,13202,58,13200,35,83,13204,13208,58,13206,35,117,13210,13214,58,13212,35,99,13216,13220,58,13218,35,99,13222,13226,58,13224,35,101,13228,13232,58,13230,35,115,13234,75,58,13236,35,115,13240,75,836,13242,13244,13276,832,13246,13248,13252,58,13250,35,102,13254,13258,58,13256,35,97,13260,13264,58,13262,35,105,13266,13270,58,13268,35,108,13272,75,58,13274,35,35,13278,13288,832,13280,712,13282,13284,75,58,13286,35,97,13290,13384,492,13292,532,13294,13296,13300,58,13298,35,117,13302,13306,58,13304,35,110,13308,13312,58,13310,35,115,13314,13318,58,13316,35,97,13320,13324,58,13322,35,102,13326,13330,58,13328,35,101,13332,13336,58,13334,35,80,13338,13342,58,13340,35,101,13344,13348,58,13346,35,114,13350,13354,58,13352,35,102,13356,13360,58,13358,35,111,13362,13366,58,13364,35,114,13368,13372,58,13370,35,109,13374,13378,58,13376,35,73,13380,75,58,13382,35,79,532,13386,13388,13392,58,13390,35,101,13394,13398,58,13396,35,120,13400,13404,58,13402,35,105,13406,13410,58,13408,35,116,13412,13416,58,13414,35,83,13418,13422,58,13420,35,117,13424,13428,58,13426,35,99,13430,13434,58,13432,35,99,13436,13440,58,13438,35,101,13442,13446,58,13444,35,115,13448,75,58,13450,35,115,13454,13456,66,836,13458,13486,66,13460,832,13462,13464,13468,58,13466,35,115,13470,13474,58,13472,35,117,13476,13480,58,13478,35,99,13482,75,58,13484,35,99,13488,832,82,13490,13492,13498,492,13494,3692,13496,35,84,13500,13508,492,13502,560,13504,662,13506,35,1,3692,13510,35,43,13514,13548,66,13516,82,13518,13520,13524,58,13522,35,43,13526,13530,58,13528,35,45,13532,13536,58,13534,35,42,13538,13542,58,13540,35,47,13544,75,58,13546,35,37,13550,13554,66,13552,66,1664,13556,13566,66,13558,66,13560,83,13562,13564,1660,66,832,13568,13570,66,66,13572,13574,66,832,3670,13576,722,13578,13580,13584,58,13582,35,73,13586,13590,58,13588,35,110,13592,75,58,13594,35,116,13598,13620,3670,13600,722,13602,13604,13608,58,13606,35,73,13610,13614,58,13612,35,110,13616,75,58,13618,35,116,722,13622,13624,13628,58,13626,35,73,13630,13634,58,13632,35,110,13636,75,58,13638,35,116,13642,13646,66,13644,82,144,13648,13652,66,13650,82,75,13654,13658,66,13656,66,83,13660,13664,66,13662,82,75,13666,13670,66,13668,66,66,13672,13778,83,13674,13676,13678,66,67,13680,13758,83,13682,13684,13686,66,67,13688,13700,66,13690,67,13692,13694,73,82,13696,13698,238,66,296,13702,13718,66,13704,83,13706,13708,13710,82,73,13712,13714,66,1202,13716,228,66,296,67,13720,13722,13724,82,75,13726,13728,66,1250,13730,13738,66,13732,82,13734,13736,316,814,1206,13740,13744,66,13742,66,66,13746,13752,66,13748,82,13750,784,338,67,13754,800,13756,1060,874,13760,13640,83,13762,13764,13766,66,67,13768,13772,66,13770,66,66,13774,13640,66,13776,66,250,13780,13786,66,13782,66,13784,66,278,13788,13792,66,13790,66,13640,67,836,13796,678,66,238,13800,13880,83,13802,13804,13806,66,67,13808,13858,66,13810,67,13812,13814,13830,82,13816,13818,13820,66,174,13822,13824,66,188,212,13826,13794,13828,35,84,13832,73,82,13834,174,13836,188,13838,13840,13854,212,13842,13844,13850,212,13846,13794,13848,35,83,13794,13852,35,73,13794,13856,35,73,13860,13864,66,13862,66,174,84,13866,188,13868,13870,13876,212,13872,13794,13874,35,83,13794,13878,35,73,13882,13886,66,13884,66,174,84,13888,188,13890,13794,13892,35,84,13896,13962,83,13898,13900,13902,66,83,13904,13908,66,13906,66,67,13910,13940,66,13912,83,13914,13916,13918,66,67,13920,13934,83,13922,13924,13926,66,67,13928,13930,66,84,13932,188,66,174,13936,212,66,13938,66,188,13942,13948,66,13944,66,13946,66,174,13950,66,82,13952,13954,13956,66,188,212,13958,13794,13960,35,66,13964,13970,66,13966,66,13968,66,162,13972,66,82,188,13976,14098,83,13978,13980,13982,66,83,13984,13988,66,13986,66,67,13990,14078,83,13992,13994,13996,66,83,13998,14002,66,14000,66,67,14004,14052,83,14006,14008,14010,66,83,14012,14016,66,14014,66,67,14018,14022,66,14020,66,84,14024,14028,66,14026,66,174,14030,14040,66,14032,82,14034,188,14036,13794,14038,35,73,14042,14044,83,66,84,14046,188,14048,13794,14050,35,83,14054,14060,66,14056,66,14058,66,174,14062,14064,66,67,14066,66,82,14068,14070,14072,66,188,212,14074,13794,14076,35,82,14080,14086,66,14082,66,14084,66,174,14088,14090,83,66,84,14092,188,14094,13794,14096,35,83,14100,14106,66,14102,66,14104,66,174,14108,14110,83,66,84,14112,188,14114,13794,14116,35,67,14120,14196,83,14122,14124,14126,66,83,14128,14132,66,14130,66,67,14134,14176,83,14136,14138,14140,66,83,14142,14146,66,14144,66,67,14148,14160,66,14150,83,14152,14154,14156,66,67,14158,174,66,84,14162,14168,66,14164,66,14166,66,162,14170,14174,66,14172,82,188,66,66,14178,14184,66,14180,66,14182,66,174,14186,14188,83,66,84,14190,188,14192,13794,14194,35,66,66,14198,66,162,14202,14208,82,14204,67,14206,14118,14200,14210,14212,66,83,14214,14220,82,14216,67,14218,13974,14200,14222,14224,66,83,14226,14232,82,14228,67,14230,13894,14200,14234,14236,66,83,14238,14242,82,14240,13798,14200,14244,73,66,66,14248,14262,82,14250,14252,14254,82,14246,14256,14258,66,66,14260,14246,66,14200,14264,14306,82,14266,14268,14278,82,14270,14200,14272,188,14274,13794,14276,35,75,14280,14282,82,73,14284,14296,82,14286,14288,14290,66,188,212,14292,13794,14294,35,75,14298,14246,82,14300,188,14302,13794,14304,35,73,14308,14310,82,188,14312,14318,82,14314,14316,14246,66,162,14320,73,82,204,14324,14352,66,14326,14328,14330,82,144,14332,14334,82,75,14336,14338,66,83,14340,14342,82,75,14344,14346,66,83,14348,73,66,14350,82,73,14354,14356,66,14246,13640,75,14360,14364,66,14362,82,846,14366,14374,66,14368,82,14370,14372,75,66,75,14376,14380,66,14378,66,83,14382,14386,66,14384,82,75,14388,14392,66,14390,66,83,14394,14444,82,14396,14398,14400,66,67,14402,14406,66,14404,82,75,14408,14412,66,14410,66,83,14414,14418,66,14416,82,75,14420,14424,66,14422,66,83,14426,14430,66,14428,82,75,14432,14436,66,14434,66,66,14438,14440,66,84,67,14442,800,876,14446,14448,66,66,14450,73,66,66,14454,14574,83,14456,14458,14460,66,67,14462,14470,66,14464,83,14466,14468,75,83,73,14472,14554,66,14474,83,14476,14478,14480,66,66,67,14482,14484,14490,82,14486,14488,75,66,75,14492,14494,66,83,14496,75,83,14498,14500,14502,66,67,14504,14510,83,14506,14508,73,66,66,14512,14514,66,67,14516,14520,66,14518,82,75,14522,14526,66,14524,66,83,14528,14532,66,14530,82,75,14534,14538,66,14536,66,83,14540,14544,66,14542,82,75,14546,14550,66,14548,66,66,14552,75,66,84,14556,14568,66,14558,67,14560,14562,14564,66,66,14566,1202,82,73,67,14570,3458,14572,924,878,14576,14452,83,14578,14580,14582,66,66,14584,14586,66,67,14588,14452,66,14590,66,14592,67,14594,14596,14608,83,14598,14600,14602,66,83,14604,14358,82,14606,35,73,14610,14896,83,14612,14614,14616,66,83,14618,14628,66,14620,83,14622,14624,14358,82,14626,35,73,14630,212,83,14632,14634,14636,66,83,14638,14798,82,14640,14642,14786,66,14644,83,14646,14648,14650,66,83,14652,14660,66,14654,82,14656,14658,75,66,75,14662,14666,66,14664,66,83,14668,14672,66,14670,82,75,14674,14678,66,14676,66,83,14680,14778,82,14682,14684,14686,66,67,14688,14692,66,14690,82,75,14694,14698,66,14696,66,83,14700,14704,66,14702,82,75,14706,14710,66,14708,66,83,14712,14716,66,14714,82,75,14718,14722,66,14720,66,83,14724,14732,66,14726,67,14728,14730,73,66,66,14734,14754,83,14736,14738,14740,66,66,14742,14744,66,83,67,14746,14748,14752,82,14750,35,66,800,874,14756,14758,66,67,14760,14772,66,14762,67,14764,14766,14770,82,14768,35,82,800,874,212,14774,13794,14776,35,84,14780,14782,66,66,14784,73,66,66,67,14788,14790,14792,66,67,14794,212,66,14796,66,212,14800,14802,66,66,14804,14806,66,67,14808,14810,82,75,14812,14814,66,83,14816,14892,82,14818,67,14820,14822,14824,82,75,14826,14828,66,83,14830,14832,82,75,14834,14836,66,83,14838,14840,82,75,14842,14844,66,83,14846,14888,82,14848,14850,14870,66,14852,83,14854,14856,14862,82,14858,13794,14860,35,84,14864,14868,82,14866,35,67,800,874,67,14872,14874,14880,82,14876,13794,14878,35,73,14882,14886,82,14884,35,66,800,874,14890,73,66,66,14894,73,66,66,14898,212,83,14900,14902,14904,66,83,14906,14916,66,14908,83,14910,14912,14358,82,14914,35,84,14918,212,83,14920,14922,14924,66,66,14926,15134,82,14928,67,14930,14932,14934,66,67,14936,14944,66,14938,82,14940,14942,75,66,75,14946,14950,66,14948,66,83,14952,14956,66,14954,82,75,14958,14962,66,14960,66,83,14964,15126,82,14966,14968,14970,66,67,14972,14976,66,14974,82,75,14978,14982,66,14980,66,83,14984,14988,66,14986,82,75,14990,14994,66,14992,66,83,14996,15000,66,14998,82,75,15002,15006,66,15004,66,83,15008,15016,66,15010,67,15012,15014,73,66,66,15018,15020,66,67,15022,15026,66,15024,82,73,15028,15032,66,15030,66,83,15034,15048,66,15036,67,15038,15040,15042,66,66,15044,15046,800,874,35,66,15050,15056,82,15052,15054,75,66,75,15058,15060,66,83,15062,15064,82,75,15066,15068,66,83,15070,15122,82,15072,67,15074,15076,15078,82,75,15080,15082,66,83,15084,15086,82,75,15088,15090,66,83,15092,15094,82,75,15096,15098,66,83,15100,15118,82,15102,67,15104,15106,15112,82,15108,13794,15110,35,86,15114,15116,800,874,35,67,15120,73,66,66,15124,73,66,66,15128,15130,66,66,15132,73,66,66,15136,15138,66,83,15140,15142,82,75,15144,15146,66,83,15148,15150,82,75,15152,73,66,66,15156,15360,83,15158,15160,15162,66,67,15164,15170,66,15166,82,15168,75,144,15172,15174,66,84,15176,15320,83,15178,15180,15182,66,67,15184,15262,83,15186,15188,15190,66,67,15192,15208,83,15194,15196,15198,66,67,15200,15202,66,84,67,15204,15206,73,66,832,15210,15258,82,15212,15214,15222,66,15216,83,15218,15220,832,66,66,15224,15242,66,15226,67,15228,15230,15232,66,66,15234,15236,66,832,15238,136,82,15240,35,2,15244,15248,66,15246,67,66,15250,836,66,15252,66,15254,836,15256,35,35,15260,73,66,66,15264,15316,82,15266,15268,15276,66,15270,83,15272,15274,832,66,66,15278,15296,66,15280,67,15282,15284,15286,66,66,15288,15290,66,832,15292,136,82,15294,35,2,15298,15302,66,15300,67,66,15304,15312,66,15306,66,15308,836,15310,35,35,15314,73,66,836,15318,73,66,66,15322,15356,82,15324,15326,15352,1250,15328,15330,15332,66,212,15334,15342,66,15336,212,15338,13794,15340,35,58,15344,13794,66,15346,212,15348,13794,15350,35,35,13794,15354,35,75,15358,15154,66,66,15362,15536,82,15364,15366,15376,66,15368,66,15370,83,15372,15374,832,66,66,15378,15386,66,15380,66,15382,66,15384,66,1012,15388,15396,66,15390,66,15392,66,15394,66,89,15398,15400,66,67,15402,15406,66,15404,66,67,15408,15414,66,15410,66,15412,66,67,15416,15424,66,15418,66,15420,66,15422,66,15154,15426,15434,66,15428,66,15430,66,15432,66,1012,15436,15442,66,15438,66,15440,66,89,67,15444,15446,15448,66,67,15450,15454,66,15452,66,67,15456,15462,66,15458,66,15460,66,67,15464,15472,66,15466,66,15468,66,15470,66,15154,15474,15514,82,15476,15478,15506,82,15480,15482,15488,82,15484,15486,1008,66,836,15490,15492,66,83,15494,15498,66,15496,66,66,15500,15504,66,15502,66,836,66,1008,15508,15510,66,66,15512,66,66,66,15516,15518,66,66,15520,15522,66,66,15524,15526,66,66,15528,15530,66,832,15532,136,82,15534,35,2,15538,15540,66,66,15542,73,66,66,15546,15550,66,15548,82,144,15552,15556,66,15554,82,75,15558,15562,66,15560,66,83,15564,15568,66,15566,82,75,15570,15574,66,15572,66,66,15576,15646,83,15578,15580,15582,66,67,15584,15626,83,15586,15588,15590,66,67,15592,15604,66,15594,67,15596,15598,73,82,15600,75,15602,35,0,15606,15612,66,15608,82,15610,35,0,15614,15620,66,15616,82,15618,35,1,67,15622,800,15624,1060,874,15628,15544,83,15630,15632,15634,66,67,15636,15640,66,15638,66,66,15642,15544,66,15644,66,136,15648,15544,83,15650,15652,15654,66,67,15656,15660,66,15658,66,66,15662,15668,66,15664,82,15666,35,0,800,15670,1060,874,15674,15544,83,15676,15678,15680,66,83,15682,15714,83,15684,15686,15688,66,83,15690,15694,66,15692,66,83,15696,15708,66,15698,66,15700,67,15702,15704,15706,798,878,35,2,15710,454,66,15712,66,492,15716,15736,66,15718,83,15720,15722,15724,66,67,15726,75,66,15728,67,15730,15732,15734,800,874,35,0,15738,8226,66,67,15742,73,83,15744,15746,15748,82,75,15750,15752,66,83,15754,15756,82,75,15758,15760,66,83,15762,15774,66,15764,82,15766,15768,15770,82,15740,15772,454,66,66,15776,15882,66,15778,82,15780,15782,15870,83,15784,15786,15788,66,83,15790,15794,66,15792,82,75,15796,15800,66,15798,66,83,15802,15806,66,15804,82,75,15808,15812,66,15810,66,83,15814,15834,82,15816,15818,15740,66,15820,67,15822,15824,15826,66,67,15828,15830,82,15740,15832,15672,66,66,15836,15838,66,66,15840,15842,66,67,15844,15850,82,15846,15848,75,66,75,15852,15854,66,83,15856,15858,82,75,15860,15862,66,83,15864,15866,82,75,15868,73,66,66,15872,15874,82,15740,15876,15878,66,66,15880,15740,66,492,15884,15886,82,75,15888,15890,66,83,15892,15894,82,75,15896,73,66,66,15900,73,83,15902,15904,15906,66,1664,15908,15910,66,84,15912,15916,66,15914,66,75,15918,15922,66,15920,83,832,15924,15932,66,15926,66,15928,15930,73,1202,1476,15934,15942,66,15936,67,15938,3458,15940,924,878,15944,75,1582,15946,15948,15950,66,84,15952,73,83,15954,15956,15958,66,67,15960,15964,66,15962,66,67,15966,15978,66,15968,67,15970,15972,15974,66,66,2914,15976,924,878,15980,15986,82,15982,15984,15740,66,14322,15988,14452,66,66,15992,16032,83,15994,15996,15998,66,67,16000,16008,66,16002,67,16004,16006,75,83,73,16010,16026,66,16012,66,16014,16016,16018,1202,1476,16020,16022,66,238,16024,73,66,678,67,16028,3458,16030,924,878,16034,15990,83,16036,16038,16040,66,67,16042,16046,66,16044,66,66,16048,15990,66,16050,66,212,16054,15898,66,16056,16058,16246,1582,16060,16062,16242,82,16064,16066,16234,82,16068,16070,16128,83,16072,16074,16076,66,67,16078,16082,66,16080,66,83,16084,16090,66,16086,66,16088,66,67,16092,16104,66,16094,83,16096,16098,16100,66,66,16102,15154,66,66,16106,16112,66,16108,66,16110,66,15990,67,16114,16116,16118,66,67,16120,1008,66,16122,67,16124,2914,16126,924,878,16130,16202,66,16132,82,16134,16136,16140,66,16138,83,73,16142,16144,66,67,16146,16150,66,16148,66,67,16152,16166,83,16154,16156,16158,66,83,16160,16164,66,16162,66,66,800,874,16168,16186,66,16170,67,16172,16174,16176,66,66,16178,16180,66,832,16182,136,82,16184,35,2,16188,16192,66,16190,67,66,16194,836,66,16196,66,16198,836,16200,35,73,16204,16208,66,16206,66,83,16210,16216,66,16212,66,16214,66,66,16218,16224,66,16220,66,16222,66,832,67,16226,16228,16230,66,67,2914,16232,924,878,16236,16238,66,66,16240,73,66,66,16244,73,66,66,16248,16250,832,75,16252,73,832,16254,35,128,16258,16294,83,16260,16262,16264,66,67,16266,16274,66,16268,83,16270,16272,75,83,73,16276,16288,66,16278,67,16280,16282,16284,66,66,16286,1202,82,73,67,16290,1682,16292,1060,874,16296,16256,83,16298,16300,16302,66,67,16304,16308,66,16306,66,66,16310,16256,66,16312,66,696,16316,73,83,16318,16320,16322,66,67,16324,16328,66,16326,66,1652,16330,16332,66,1664,16334,16256,66,1024,16338,16360,83,16340,16342,16344,66,67,16346,16356,66,16348,67,16350,16352,73,82,16354,75,846,800,16358,1060,874,16362,16336,83,16364,16366,16368,66,67,16370,16374,66,16372,66,66,16376,16336,66,16378,66,1050,16382,16470,83,16384,16386,16388,66,83,16390,16426,83,16392,16394,16396,66,83,16398,16402,66,16400,83,73,16404,16408,66,16406,66,75,16410,16414,66,16412,66,784,16416,16420,66,16418,82,75,16422,832,66,16424,66,836,16428,16434,66,16430,66,16432,66,784,16436,16458,83,16438,16440,16442,66,66,16444,16446,66,67,16448,16452,66,16450,82,75,67,16454,800,16456,1060,874,16460,16464,66,16462,82,75,16466,832,66,16468,66,836,16472,16476,66,16474,66,75,16478,16482,66,16480,66,75,16484,16496,83,16486,16488,16490,66,83,16492,16336,66,16494,82,75,16498,16502,66,16500,66,784,16504,16508,66,16506,82,75,16510,832,66,16512,66,836,16516,16592,66,16518,83,16520,16522,16524,66,83,16526,16530,82,16528,67,16380,16532,16534,66,83,16536,16542,83,16538,16540,73,66,66,16544,16554,66,16546,66,16548,82,16550,75,16552,75,75,16556,16590,66,16558,67,16560,16562,16564,66,67,16566,16586,82,16568,16570,16574,66,16572,82,75,16576,16582,66,16578,82,16580,784,75,800,16584,1060,874,16588,73,66,66,67,16380,16594,16628,66,16596,67,16598,16600,16602,66,67,16604,16608,66,16606,66,66,16610,16614,66,16612,66,66,16616,16626,66,16618,67,16620,16622,73,82,16624,75,75,67,16380,16630,73,83,16632,16634,16636,66,67,16638,16642,66,16640,66,66,16644,16648,66,16646,66,67,16650,16656,66,16652,66,16654,66,66,16658,16514,66,16660,66,16662,66,16664,802,1240,16668,16682,66,16670,66,16672,83,16674,16676,16680,66,16678,814,1206,67,16314,16684,16688,82,16686,67,16256,16690,16692,66,66,16694,16696,66,83,16698,16704,66,16700,66,16702,16514,16666,67,16256,16708,16798,82,16710,16712,16784,66,16714,66,16716,82,16718,16720,16728,66,16722,67,16724,16726,73,66,66,16730,16768,66,16732,82,16734,16736,16744,66,16738,67,16740,16742,73,66,66,16746,16748,66,67,16750,16754,66,16752,66,67,16756,16762,66,16758,66,16760,66,832,16764,696,66,16766,66,832,16770,16774,66,16772,66,66,16776,16780,66,16778,66,67,16782,16706,66,67,16786,16792,66,16788,66,16790,66,66,16794,16796,66,67,67,16706,16800,16802,66,83,16804,16808,66,16806,66,83,16810,16922,82,16812,16814,16910,83,16816,16818,16820,66,83,16822,16826,66,16824,66,67,16828,16842,66,16830,83,16832,16834,16836,66,83,67,16838,1682,16840,1060,874,16844,16902,83,16846,16848,16850,66,67,16852,16856,66,16854,66,67,16858,16872,82,16860,67,16862,16864,16866,66,67,16868,832,66,16870,66,836,16874,16876,66,66,16878,16880,66,66,16882,16884,66,83,16886,16890,66,16888,66,832,16892,16896,66,16894,67,832,16898,136,82,16900,35,1,16904,16906,66,712,16908,4082,82,75,16912,16914,66,67,16916,16920,66,16918,66,832,67,832,16924,16926,66,83,16928,16932,66,16930,66,83,16934,16944,83,16936,16938,16940,66,66,16942,73,66,66,16946,16952,66,16948,66,16950,66,75,16954,832,66,16956,66,832,16960,17036,82,16962,16964,17028,82,16966,16968,16978,66,16970,66,16972,67,16974,16976,73,66,66,16980,16986,82,16982,16984,16706,66,67,16988,16990,66,66,16992,16994,66,66,16996,16998,66,67,17000,17004,66,17002,66,66,17006,17010,66,17008,66,1018,17012,17016,66,17014,66,1018,17018,404,66,17020,67,17022,17024,17026,66,66,67,836,17030,17032,66,66,17034,73,66,66,17038,73,66,66,17042,17110,82,17044,17046,17088,66,17048,82,17050,17052,17060,66,17054,67,17056,17058,73,66,66,17062,17076,66,17064,66,17066,67,17068,17070,17072,66,66,17074,400,66,1018,17078,17084,66,17080,66,17082,66,1008,17086,16706,66,67,17090,17094,66,17092,66,66,17096,17100,66,17098,1250,16958,17102,17104,82,75,17106,17108,66,832,832,75,17112,73,66,66,17116,17118,82,73,17120,17122,66,83,17124,17218,83,17126,17128,17130,66,67,17132,17136,66,17134,66,67,17138,17142,66,17140,82,75,17144,17148,66,17146,66,83,17150,17208,83,17152,17154,17156,66,67,17158,17162,66,17160,66,67,17164,17188,66,17166,67,17168,17170,17172,66,67,17174,17176,82,75,17178,17180,66,83,17182,17184,82,75,17186,73,66,66,17190,17114,83,17192,17194,17196,66,67,17198,17202,66,17200,66,66,17204,17114,66,17206,66,492,17210,17114,66,17212,67,17214,17216,454,66,66,17220,17222,66,84,17224,17230,66,17226,66,17228,66,412,17232,16256,66,17234,67,17236,17238,404,66,66,17242,17252,66,17244,66,17246,66,17248,66,17250,83,73,17254,17274,66,17256,66,17258,66,17260,66,17262,66,17264,82,17266,17268,17270,66,712,17272,4082,82,75,17276,17288,66,17278,66,17280,66,17282,66,17284,66,17286,66,83,17290,17372,66,17292,66,17294,82,17296,17298,17310,66,17300,66,17302,67,17304,17306,17308,66,67,67,17040,17312,17322,66,17314,66,17316,67,17318,17320,73,66,66,17324,17326,82,832,17328,17330,66,66,17332,17334,66,66,17336,17338,66,67,17340,17344,66,17342,66,67,17346,17352,66,17348,66,17350,66,832,17354,17360,66,17356,66,17358,67,832,17362,17366,82,17364,1664,412,17368,17370,66,66,1582,492,17374,17380,66,17376,66,17378,66,83,17382,17390,66,17384,66,17386,66,17388,66,67,17392,17402,66,17394,66,17396,66,17398,66,17400,66,83,17404,17416,66,17406,66,17408,66,17410,66,17412,66,17414,66,83,17418,17432,66,17420,66,17422,66,17424,66,17426,66,17428,66,17430,66,67,17434,17452,66,17436,66,17438,66,17440,66,17442,66,17444,66,17446,66,17448,66,17450,82,144,17454,17472,66,17456,66,17458,66,17460,66,17462,66,17464,66,17466,66,17468,66,17470,82,75,17474,17492,66,17476,66,17478,66,17480,66,17482,66,17484,66,17486,66,17488,66,17490,66,83,17494,17512,66,17496,66,17498,66,17500,66,17502,66,17504,66,17506,66,17508,66,17510,82,75,17514,17532,66,17516,66,17518,66,17520,66,17522,66,17524,66,17526,66,17528,66,17530,66,66,17534,18492,83,17536,17538,17540,66,83,17542,17546,66,17544,66,83,17548,17554,66,17550,66,17552,66,67,17556,17564,66,17558,66,17560,66,17562,66,67,17566,17576,66,17568,66,17570,66,17572,66,17574,66,83,17578,17590,66,17580,66,17582,66,17584,66,17586,66,17588,66,83,17592,17606,66,17594,66,17596,66,17598,66,17600,66,17602,66,17604,66,83,17608,17624,66,17610,66,17612,66,17614,66,17616,66,17618,66,17620,66,17622,66,67,17626,18122,66,17628,83,17630,17632,17634,66,83,17636,17640,66,17638,66,67,17642,17648,66,17644,66,17646,66,67,17650,17658,66,17652,66,17654,66,17656,66,66,17660,17668,66,17662,66,17664,66,17666,66,66,17670,17678,66,17672,66,17674,66,17676,66,66,17680,17688,66,17682,66,17684,66,17686,66,67,17690,17960,66,17692,66,17694,83,17696,17698,17700,66,83,17702,17706,66,17704,66,83,17708,17718,83,17710,17712,17714,66,66,17716,73,66,66,17720,17904,83,17722,17724,17726,66,83,17728,17732,66,17730,66,67,17734,17740,66,17736,66,17738,66,67,17742,17866,83,17744,17746,17748,66,83,17750,17754,66,17752,66,67,17756,17762,66,17758,66,17760,66,67,17764,17834,66,17766,66,17768,67,17770,17772,17774,66,67,17776,17778,66,84,17780,17784,66,17782,82,144,17786,17796,66,17788,67,17790,17792,17794,800,874,35,89,17798,73,82,17800,3690,17802,17804,17826,3670,17806,17808,17818,3670,17810,712,17812,17814,75,58,17816,35,97,712,17820,17822,75,58,17824,35,97,712,17828,17830,75,58,17832,35,97,17836,17840,66,17838,66,75,17842,17844,66,832,832,17846,722,17848,17850,17854,58,17852,35,73,17856,17860,58,17858,35,110,17862,75,58,17864,35,116,17868,17872,66,17870,66,75,17874,17876,66,832,832,17878,722,17880,17882,17886,58,17884,35,67,17888,17892,58,17890,35,104,17894,17898,58,17896,35,97,17900,75,58,17902,35,114,17906,17910,66,17908,66,75,17912,17914,66,832,832,17916,17918,17934,696,17920,722,17922,17924,17928,58,17926,35,91,17930,75,58,17932,35,93,722,17936,17938,17942,58,17940,35,67,17944,17948,58,17946,35,104,17950,17954,58,17952,35,97,17956,75,58,17958,35,114,17962,17980,66,17964,82,17966,17968,17978,66,17970,67,17972,17974,17976,66,66,67,832,67,832,17982,17986,66,17984,66,66,17988,17992,66,17990,66,66,17994,17998,66,17996,66,67,18000,18006,66,18002,66,18004,66,67,18008,18026,66,18010,67,18012,18014,18016,66,66,18018,18020,66,83,67,18022,1682,18024,1060,874,18028,18030,66,67,18032,18112,82,18034,18036,18038,66,1448,1652,18040,18042,18046,58,18044,35,98,18048,18052,58,18050,35,97,18054,18058,58,18056,35,100,18060,18064,58,18062,35,32,18066,18070,58,18068,35,115,18072,18076,58,18074,35,121,18078,18082,58,18080,35,109,18084,18088,58,18086,35,98,18090,18094,58,18092,35,111,18096,18100,58,18098,35,108,18102,18106,58,18104,35,58,18108,75,58,18110,35,32,18114,18116,66,83,67,18118,3458,18120,924,878,18124,18238,83,18126,18128,18130,66,83,18132,18136,66,18134,66,83,18138,18144,66,18140,66,18142,66,67,18146,18154,66,18148,66,18150,66,18152,66,67,18156,18166,66,18158,66,18160,66,18162,66,18164,66,66,18168,18178,66,18170,66,18172,66,18174,66,18176,66,67,18180,18192,66,18182,66,18184,66,18186,66,18188,66,18190,66,66,18194,18214,66,18196,66,18198,82,18200,18202,18210,82,18204,18206,136,82,18208,35,1,18212,832,66,66,18216,18222,66,18218,66,18220,66,66,18224,18230,66,18226,66,18228,66,66,18232,17240,66,18234,66,18236,66,67,18240,18256,66,18242,66,18244,66,18246,66,18248,66,18250,67,18252,18254,73,66,66,18258,18442,66,18260,66,18262,82,18264,18266,18278,66,18268,66,18270,66,18272,67,18274,18276,73,66,66,18280,18328,83,18282,18284,18286,66,66,18288,18290,66,67,18292,18296,66,18294,66,66,18298,18302,66,18300,66,66,18304,18308,66,18306,66,67,18310,18316,66,18312,66,18314,66,832,18318,18320,82,492,18322,18324,66,66,18326,832,66,66,18330,18334,66,18332,66,67,18336,18342,66,18338,66,18340,66,1018,18344,18430,66,18346,66,18348,66,18350,66,18352,18354,73,1202,18356,1448,18358,18360,18364,58,18362,35,117,18366,18370,58,18368,35,110,18372,18376,58,18374,35,105,18378,18382,58,18380,35,102,18384,18388,58,18386,35,121,18390,18394,58,18392,35,32,18396,18400,58,18398,35,102,18402,18406,58,18404,35,97,18408,18412,58,18410,35,105,18414,18418,58,18416,35,108,18420,18424,58,18422,35,101,18426,75,58,18428,35,100,18432,18440,66,18434,67,18436,18438,16666,66,66,67,3670,18444,18450,66,18446,66,18448,66,66,18452,18458,66,18454,66,18456,66,67,18460,18468,66,18462,66,18464,66,18466,66,67,18470,18480,66,18472,66,18474,66,18476,66,18478,66,66,18482,17240,66,18484,66,18486,66,18488,66,18490,66,66,18494,18552,66,18496,66,18498,66,18500,66,18502,66,18504,83,18506,18508,18510,66,83,18512,18516,66,18514,66,66,18518,18522,66,18520,66,1018,18524,18528,66,18526,66,84,18530,18532,82,454,18534,18536,66,66,18538,18540,66,67,18542,18546,66,18544,66,66,18548,3670,66,18550,66,832,18554,18574,66,18556,66,18558,82,18560,18562,18570,82,18564,18566,136,82,18568,35,1,18572,832,66,66,18576,18582,66,18578,66,18580,66,66,18584,18590,66,18586,66,18588,66,66,18592,18598,66,18594,66,18596,66,67,18600,18608,66,18602,66,18604,66,18606,66,67,18610,18620,66,18612,66,18614,66,18616,66,18618,66,67,18622,18640,66,18624,82,18626,67,18628,18630,18632,66,67,18634,18638,66,18636,66,836,67,832,18642,18646,66,18644,66,66,18648,18652,66,18650,66,66,18654,17240,66,18656,66,66,18660,18782,66,18662,66,18664,66,18666,82,18668,18670,18778,82,18672,18674,18770,82,18676,18678,18734,83,18680,18682,18684,66,66,18686,18688,66,67,18690,18694,66,18692,66,66,18696,18700,66,18698,82,144,16666,18702,712,18704,18706,18710,58,18708,35,115,18712,18716,58,18714,35,101,18718,18722,58,18720,35,108,18724,18728,58,18726,35,102,18730,75,58,18732,35,33,18736,18740,66,18738,66,67,18742,18748,66,18744,66,18746,66,832,18750,18754,82,18752,67,17114,18756,18758,66,66,18760,18762,66,83,18764,18768,66,18766,66,832,67,16256,18772,18774,66,66,18776,73,66,66,18780,73,66,66,18784,17240,66,18786,66,18788,66,18790,82,18792,18794,18796,832,75,35,0,84,18800,18802,18806,66,18804,82,846,18808,18880,82,18810,18812,18814,66,67,18816,18820,66,18818,66,67,18822,18852,82,18824,18826,18830,82,18828,800,18798,18832,18834,66,66,18836,18838,66,67,18840,18844,66,18842,66,66,18846,18850,66,18848,66,1054,800,18798,18854,18856,66,66,18858,18860,66,66,18862,18864,66,67,18866,18868,82,75,18870,18872,66,83,18874,18876,82,75,18878,73,66,66,18882,18884,66,83,18886,18890,66,18888,66,83,18892,18938,82,18894,18896,18898,66,67,18900,18908,66,18902,82,18904,18906,75,66,75,18910,18914,66,18912,66,83,18916,18922,82,18918,800,18920,1060,874,18924,18926,66,66,18928,18930,66,67,18932,18934,82,75,18936,73,66,66,18940,18942,66,83,18944,18948,66,18946,66,83,18950,18996,82,18952,18954,18956,66,67,18958,18966,66,18960,82,18962,18964,75,66,75,18968,18972,66,18970,66,83,18974,18978,66,18976,82,75,18980,18984,66,18982,66,66,18986,18992,82,18988,800,18990,1060,874,18994,73,66,66,18998,19000,66,66,19002,73,66,66,84,19006,19008,19052,82,19010,19012,19044,82,19014,19016,19020,82,19018,800,18798,19022,19024,66,66,19026,19028,66,67,19030,19034,66,19032,66,66,19036,19040,66,19038,66,1054,800,19042,1060,874,19046,19048,66,66,19050,73,66,66,19054,73,66,66,19058,19060,82,75,19062,19064,66,1250,19066,19070,66,19068,82,73,19072,19076,66,19074,66,83,19078,19080,82,836,19082,19084,66,83,19086,73,66,19088,66,66,19092,19094,66,67,19096,19100,66,19098,66,19056,19102,19110,66,19104,66,19106,82,19108,75,75,19112,19118,66,19114,66,19116,82,846,19120,19122,66,67,19124,800,66,19126,66,1636,19130,19134,66,19132,82,75,19136,19212,83,19138,19140,19142,66,83,19144,19192,83,19146,19148,19150,66,83,19152,19156,66,19154,66,1736,19158,19168,82,19160,19162,19164,82,712,19166,16256,66,66,19170,19172,66,66,19174,19176,66,83,19178,19184,66,19180,66,19182,800,18798,19186,19188,82,712,19190,16256,66,66,19194,19198,82,19196,1664,1008,19200,19202,66,66,19204,19210,66,19206,19090,19208,1060,874,1664,1008,19214,1652,66,19216,66,784,19220,19304,82,19222,19224,19230,66,19226,66,19228,82,75,19232,19276,82,19234,19236,19256,82,19238,19240,19244,66,19242,82,19128,19246,19250,66,19248,66,66,19252,19218,66,19254,82,75,19258,19260,66,66,19262,19264,66,67,19266,19270,66,19268,66,66,19272,19218,66,19274,82,75,19278,19280,66,66,19282,19284,66,66,19286,19288,66,67,19290,19292,82,75,19294,19296,66,83,19298,19300,82,75,19302,73,66,66,19306,19308,66,83,19310,19332,82,19312,19314,19318,66,19316,66,784,19320,19324,66,19322,82,75,19326,19330,66,19328,66,836,67,832,19334,19336,66,83,19338,19402,82,19340,19342,19346,66,19344,82,75,19348,19356,66,19350,82,19352,19354,75,66,75,19358,19362,66,19360,66,83,19364,19368,66,19366,82,75,19370,19374,66,19372,66,83,19376,19394,82,19378,19380,19382,66,67,19384,19390,66,19386,82,19388,784,75,800,19392,1060,874,19396,19398,66,66,19400,73,66,66,19404,73,66,66,19408,19416,66,19410,66,19412,836,19414,35,40,19418,66,82,19420,836,19422,35,41,19426,19632,82,19428,19430,19604,83,19432,19434,19436,66,83,19438,19580,82,19440,19442,19444,66,67,19446,19450,66,19448,66,67,19452,19462,66,19454,66,19456,82,19458,19460,75,66,75,19464,19470,66,19466,66,19468,66,83,19472,19478,66,19474,66,19476,82,75,19480,19486,66,19482,66,19484,66,83,19488,19500,66,19490,67,19492,19494,19496,66,66,19498,73,66,66,19502,19506,66,19504,66,67,19508,19532,66,19510,66,19512,67,19514,19516,19520,800,19518,1060,874,19522,19526,58,19524,35,45,19528,75,58,19530,35,62,19534,19538,66,19536,66,19406,19540,19548,66,19542,67,19544,19546,19424,66,66,19550,19424,66,19552,66,19554,1652,19556,19558,19562,58,19560,35,32,19564,19568,58,19566,35,45,19570,19574,58,19572,35,62,19576,75,58,19578,35,32,19582,19584,66,66,19586,19588,66,83,19590,19592,82,75,19594,19596,66,83,19598,19600,82,75,19602,73,66,66,19606,19610,66,19608,66,19406,19612,19624,82,19614,19616,19424,66,19618,66,19620,836,19622,35,32,19626,19628,66,66,19630,19424,66,66,19634,19636,82,1652,19638,73,82,1652,19642,73,82,19644,19646,19692,82,19648,19650,19658,66,19652,66,19654,836,19656,35,32,19660,19688,82,19662,1652,19664,19666,19670,58,19668,35,32,19672,19676,58,19674,35,61,19678,19682,58,19680,35,62,19684,75,58,19686,35,32,19690,19424,66,66,19694,19696,66,66,19698,1652,66,66,19702,19710,66,19704,66,19706,836,19708,35,123,19712,19740,82,19714,19716,19724,82,19718,19720,75,58,19722,35,125,19726,19728,66,1652,19730,19736,66,19732,836,19734,35,32,19738,19424,82,75,19742,1652,66,66,19746,19756,66,19748,66,19750,83,19752,19754,73,66,66,19758,19904,66,19760,83,19762,19764,19766,66,83,19768,19772,66,19770,66,67,19774,19780,66,19776,66,19778,66,66,19782,19788,66,19784,66,19786,66,66,19790,19794,66,19792,66,84,19796,19900,82,19798,19800,19816,66,19802,82,19804,19806,19812,66,19808,836,19810,35,42,19814,4082,82,75,19818,19822,66,19820,66,83,19824,19832,66,19826,66,19828,66,19830,66,774,19834,19840,66,19836,66,19838,82,532,19842,19848,66,19844,66,19846,66,83,19850,19858,66,19852,66,19854,66,19856,66,832,19860,19870,66,19862,82,19864,19866,136,82,19868,35,1,19872,19876,66,19874,66,66,19878,19882,66,19880,66,67,19884,19890,66,19886,66,19888,66,832,19892,19894,66,67,19896,832,66,19898,66,836,19902,73,66,66,19906,19922,66,19908,66,19910,66,19912,66,19914,66,19916,67,19918,19920,73,66,66,19924,20006,83,19926,19928,19930,66,83,19932,19936,66,19934,66,67,19938,19944,66,19940,66,19942,66,66,19946,19952,66,19948,66,19950,66,67,19954,19962,66,19956,66,19958,66,19960,66,67,19964,19974,66,19966,66,19968,66,19970,66,19972,66,66,19976,19986,66,19978,66,19980,66,19982,66,19984,66,83,19988,19744,66,19990,66,19992,66,19994,67,19996,19998,20000,66,66,20002,20004,66,67,67,19218,20008,20014,66,20010,66,20012,66,67,20016,20024,66,20018,66,20020,66,20022,66,67,20026,20046,82,20028,20030,20038,82,20032,20034,19700,66,20036,66,532,20040,20042,66,66,20044,832,66,66,20048,20050,66,66,20052,20054,66,66,20056,20058,66,66,20060,20062,66,67,20064,20072,66,20066,66,20068,20070,2012,1352,1980,20074,20084,66,20076,66,20078,67,20080,20082,73,66,66,20086,20100,66,20088,66,20090,67,20092,20094,20096,66,66,20098,73,66,66,20102,20128,66,20104,66,20106,66,20108,67,20110,20112,20114,66,66,20116,20118,66,66,20120,20124,66,20122,814,1966,20126,492,66,1024,20130,20134,66,20132,66,67,20136,20142,66,20138,66,20140,66,67,20144,20156,82,20146,20148,16256,66,20150,67,20152,20154,404,66,66,20158,20160,66,66,20162,66,66,66,20166,20172,66,20168,66,20170,83,73,20174,20182,66,20176,66,20178,66,20180,66,75,20184,20202,66,20186,82,20188,20190,20194,66,20192,66,774,20196,20198,82,532,20200,832,66,66,20204,20208,66,20206,66,83,20210,20216,66,20212,66,20214,66,67,20218,20232,66,20220,83,20222,20224,20226,66,66,20228,20230,66,67,1682,19004,20234,20242,66,20236,83,20238,20240,73,66,66,20244,20252,66,20246,66,20248,66,20250,66,75,20254,20372,83,20256,20258,20260,66,66,20262,20264,66,66,20266,20268,66,67,20270,20362,82,20272,20274,20276,66,778,1652,20278,20280,20284,58,20282,35,110,20286,20290,58,20288,35,111,20292,20296,58,20294,35,32,20298,20302,58,20300,35,105,20304,20308,58,20306,35,110,20310,20314,58,20312,35,115,20316,20320,58,20318,35,116,20322,20326,58,20324,35,97,20328,20332,58,20330,35,110,20334,20338,58,20336,35,99,20340,20344,58,20342,35,101,20346,20350,58,20348,35,115,20352,20356,58,20354,35,58,20358,75,58,20360,35,32,20364,20366,66,83,67,20368,3458,20370,924,878,20374,20376,66,67,20378,20164,66,19744,20382,20390,82,20384,20386,832,66,20388,66,774,20392,20394,66,83,20396,20400,66,20398,66,83,20402,20572,83,20404,20406,20408,66,83,20410,20414,66,20412,66,67,20416,20422,66,20418,66,20420,66,67,20424,20430,66,20426,66,20428,82,75,20432,20438,66,20434,66,20436,66,83,20440,20550,83,20442,20444,20446,66,83,20448,20452,66,20450,66,67,20454,20460,66,20456,66,20458,66,67,20462,20488,66,20464,66,20466,67,20468,20470,20472,66,67,20474,20476,82,75,20478,20480,66,83,20482,20484,82,75,20486,73,66,66,20490,20520,83,20492,20494,20496,66,67,20498,20502,66,20500,66,67,20504,20510,66,20506,66,20508,66,66,20512,20380,66,20514,66,20516,66,20518,802,2012,20522,20526,66,20524,66,84,20528,20546,66,20530,66,20532,66,20534,67,20536,20538,20542,66,20540,814,1966,20544,492,66,1024,20548,20380,66,67,20552,20380,66,20554,66,20556,67,20558,20560,20562,66,66,20564,20568,66,20566,814,1966,20570,454,66,1024,20574,20164,66,67,20578,20636,82,20580,20582,20624,83,20584,20586,20588,66,67,20590,20594,66,20592,66,66,20596,20600,66,20598,66,1018,20602,20606,66,20604,66,836,20608,20612,66,20610,67,832,20614,20620,66,20616,836,20618,35,42,20622,4082,82,75,20626,20630,66,20628,67,20576,20632,136,82,20634,35,1,20638,20640,66,83,20642,20646,82,20644,832,75,20648,73,66,66,20652,20660,66,20654,66,20656,66,20658,66,84,20662,20678,66,20664,66,20666,66,20668,67,20670,20672,20674,66,66,20676,73,66,66,20680,20722,66,20682,67,20684,20686,20688,66,83,20690,20694,66,20692,66,66,20696,20700,66,20698,66,67,20702,20708,66,20704,66,20706,66,66,20710,20716,66,20712,66,20714,66,66,20718,18658,66,20720,82,75,20724,20740,66,20726,66,20728,66,20730,66,20732,66,20734,67,20736,20738,73,66,66,20742,20896,66,20744,67,20746,20748,20750,66,67,20752,20756,66,20754,66,66,20758,20762,66,20760,66,66,20764,20768,66,20766,66,66,20770,20774,66,20772,66,66,20776,20780,66,20778,66,66,20782,20886,82,20784,20786,20788,66,778,1652,20790,20792,20796,58,20794,35,110,20798,20802,58,20800,35,111,20804,20808,58,20806,35,32,20810,20814,58,20812,35,115,20816,20820,58,20818,35,117,20822,20826,58,20824,35,99,20828,20832,58,20830,35,104,20834,20838,58,20836,35,32,20840,20844,58,20842,35,109,20846,20850,58,20848,35,101,20852,20856,58,20854,35,116,20858,20862,58,20860,35,104,20864,20868,58,20866,35,111,20870,20874,58,20872,35,100,20876,20880,58,20878,35,58,20882,75,58,20884,35,32,20888,20890,66,83,67,20892,3458,20894,924,878,20898,20920,66,20900,66,20902,66,20904,67,20906,20908,20910,66,66,20912,20914,66,66,20916,20918,66,67,67,17040,20922,20938,66,20924,66,20926,66,20928,66,20930,66,20932,67,20934,20936,73,66,66,20940,20956,66,20942,66,20944,66,20946,66,20948,66,20950,66,20952,66,20954,82,144,20958,20980,66,20960,66,20962,66,20964,66,20966,66,20968,66,20970,67,20972,20974,20976,66,66,20978,73,66,83,20982,21004,66,20984,66,20986,66,20988,66,20990,66,20992,66,20994,66,20996,66,20998,67,21000,21002,73,66,66,21006,21024,66,21008,66,21010,66,21012,66,21014,66,21016,66,21018,66,21020,66,21022,66,75,21026,21044,66,21028,66,21030,66,21032,66,21034,66,21036,66,21038,82,21040,21042,75,66,75,21046,21060,66,21048,66,21050,66,21052,66,21054,66,21056,66,21058,66,66,21062,21076,66,21064,66,21066,66,21068,66,21070,66,21072,66,21074,66,67,21078,21094,66,21080,66,21082,66,21084,66,21086,66,21088,66,21090,66,21092,66,67,21096,21116,66,21098,66,21100,66,21102,66,21104,66,21106,66,21108,66,21110,67,21112,21114,73,66,66,21118,21152,66,21120,66,21122,67,21124,21126,21128,66,66,21130,21132,66,66,21134,21136,66,66,21138,21140,66,66,21142,21144,66,67,21146,21150,66,21148,82,144,67,19218,21154,21216,66,21156,67,21158,21160,21162,66,66,21164,21166,66,66,21168,21170,66,67,21172,21176,66,21174,66,67,21178,21184,66,21180,66,21182,66,67,21186,21188,66,67,21190,21194,66,21192,66,67,21196,21202,66,21198,66,21200,66,17040,21204,21208,82,21206,67,16256,21210,21212,66,66,21214,400,66,66,21218,21226,66,21220,66,21222,66,21224,66,75,21228,21234,66,21230,66,21232,66,84,21236,21428,66,21238,67,21240,21242,21244,66,66,21246,21248,66,66,21250,21252,66,67,21254,19218,66,21256,82,21258,778,21260,21262,21266,58,21264,35,99,21268,21272,58,21270,35,108,21274,21278,58,21276,35,97,21280,21284,58,21282,35,115,21286,21290,58,21288,35,115,21292,21296,58,21294,35,47,21298,21302,58,21300,35,105,21304,21308,58,21306,35,110,21310,21314,58,21312,35,115,21316,21320,58,21318,35,116,21322,21326,58,21324,35,97,21328,21332,58,21330,35,110,21334,21338,58,21336,35,99,21340,21344,58,21342,35,101,21346,21350,58,21348,35,32,21352,21356,58,21354,35,116,21358,21362,58,21360,35,121,21364,21368,58,21366,35,112,21370,21374,58,21372,35,101,21376,21380,58,21378,35,32,21382,21386,58,21384,35,99,21388,21392,58,21390,35,111,21394,21398,58,21396,35,110,21400,21404,58,21402,35,102,21406,21410,58,21408,35,108,21412,21416,58,21414,35,105,21418,21422,58,21420,35,99,21424,75,58,21426,35,116,21430,21442,66,21432,66,21434,66,21436,66,21438,21440,1012,814,1966,21444,21448,82,21446,67,17114,21450,21452,66,66,21454,21456,66,67,21458,21462,66,21460,66,66,21464,21472,82,21466,21468,20576,82,21470,35,0,21474,20380,66,66,21478,21484,66,21480,66,21482,66,84,21486,21494,66,21488,66,21490,66,21492,66,84,21496,21510,66,21498,66,21500,66,21502,66,21504,83,21506,21508,73,66,66,21512,21664,66,21514,66,21516,66,21518,67,21520,21522,21524,66,66,21526,21528,66,66,21530,21532,66,67,21534,21538,66,21536,66,67,21540,21548,66,21542,66,21544,66,21546,814,1966,21550,21644,82,21552,21554,21588,66,21556,66,21558,832,21560,3690,21562,722,21564,21566,21570,58,21568,35,68,21572,21576,58,21574,35,73,21578,21582,58,21580,35,67,21584,75,58,21586,35,84,21590,21616,82,21592,21594,21604,66,21596,454,21598,21600,75,58,21602,35,64,21606,21608,1582,492,532,21610,21612,75,58,21614,35,64,21618,21620,66,66,21622,21628,66,21624,67,21626,1250,454,21630,21634,66,21632,1664,1012,21636,21638,66,1008,21640,20576,82,21642,35,0,21646,21648,66,66,21650,21652,66,67,21654,21658,66,21656,66,66,21660,19700,66,21662,66,832,21666,20650,66,21668,66,21670,66,21672,66,21674,21676,1966,1288,1980,21680,21726,66,21682,66,21684,83,21686,21688,73,82,21690,21692,21694,812,1856,532,21696,21698,21702,58,21700,35,106,21704,21708,58,21706,35,111,21710,21714,58,21712,35,105,21716,21720,58,21718,35,110,21722,75,58,21724,35,35,21728,21736,66,21730,66,21732,66,21734,66,75,21738,21744,66,21740,66,21742,66,84,21746,21754,66,21748,66,21750,66,21752,66,75,21756,21822,66,21758,66,21760,83,21762,21764,21766,66,83,21768,21770,66,84,21772,21776,66,21774,812,1856,21778,21818,66,21780,1532,21782,21784,21786,66,492,454,21788,21790,21794,58,21792,35,106,21796,21800,58,21798,35,111,21802,21806,58,21804,35,105,21808,21812,58,21810,35,110,21814,75,58,21816,35,35,21820,1012,814,1674,21824,21832,66,21826,66,21828,66,21830,66,75,21834,21842,66,21836,66,21838,66,21840,66,75,21844,21850,66,21846,66,21848,82,1274,21852,21858,66,21854,66,21856,66,66,21860,21872,66,21862,66,21864,66,21866,66,21868,21870,1946,802,1906,21874,21902,66,21876,66,21878,66,21880,83,21882,21884,21886,66,83,21888,21894,66,21890,66,21892,862,1906,21896,21900,66,21898,66,1952,67,136,21904,21936,66,21906,66,21908,82,21910,21912,21932,82,21914,21916,1756,66,21918,21920,21922,814,1674,21924,4082,82,21926,21928,75,58,21930,35,35,21934,1152,66,66,21938,21944,66,21940,66,21942,66,66,21946,21952,66,21948,66,21950,66,66,21954,21966,66,21956,66,21958,66,21960,83,21962,21964,73,82,144,21968,22170,83,21970,21972,21974,66,83,21976,21980,66,21978,66,67,21982,21988,66,21984,66,21986,66,66,21990,21996,66,21992,66,21994,66,66,21998,22004,66,22000,66,22002,66,67,22006,22016,66,22008,66,22010,66,22012,66,22014,802,1906,22018,22034,66,22020,66,22022,67,22024,22026,22028,66,66,67,22030,22032,1840,1288,1856,22036,22042,66,22038,66,22040,66,84,22044,22060,66,22046,66,22048,66,22050,67,22052,22054,22056,66,66,22058,73,82,144,22062,22082,66,22064,66,22066,66,22068,66,22070,67,22072,22074,22076,66,66,22078,832,66,22080,814,1840,22084,22090,66,22086,82,22088,67,1834,22092,22096,66,22094,66,66,22098,22102,66,22100,66,67,22104,22110,66,22106,66,22108,66,66,22112,22120,66,22114,66,22116,22118,1906,1352,1856,22122,22128,66,22124,66,22126,66,84,22130,22148,66,22132,82,22134,22136,22140,66,22138,82,75,22142,22146,66,22144,66,836,67,832,22150,22154,66,22152,66,66,22156,22160,66,22158,66,66,22162,22166,66,22164,66,67,66,22168,82,75,22172,22196,66,22174,66,22176,67,22178,22180,22182,66,66,22184,22186,66,66,22188,22192,66,22190,814,1840,67,22194,1250,454,66,22198,82,75,22202,22208,66,22204,66,22206,66,492,22210,22248,66,22212,66,22214,66,22216,454,22218,22220,22224,58,22222,35,106,22226,22230,58,22228,35,111,22232,22236,58,22234,35,105,22238,22242,58,22240,35,110,22244,75,58,22246,35,35,22250,22288,66,22252,66,22254,82,22256,532,22258,22260,22264,58,22262,35,106,22266,22270,58,22268,35,111,22272,22276,58,22274,35,105,22278,22282,58,22280,35,110,22284,75,58,22286,35,35,22290,22296,66,22292,66,22294,66,492,22298,22302,66,22300,66,492,22304,22324,66,22306,66,22308,492,22310,532,22312,22314,22318,58,22316,35,105,22320,75,58,22322,35,102,22326,22328,66,492,492,22330,532,22332,22334,22338,58,22336,35,61,22340,75,58,22342,35,61,22346,22344,83,22348,22350,22352,66,83,22354,22358,66,22356,66,67,22360,22366,66,22362,66,22364,66,67,22368,22978,66,22370,83,22372,22374,22376,66,83,22378,22382,66,22380,66,67,22384,22390,66,22386,66,22388,66,67,22392,22450,66,22394,66,22396,67,22398,22400,22402,66,66,22404,22406,66,83,22408,22446,82,22410,22412,73,82,22414,532,22416,22418,22422,58,22420,35,106,22424,22428,58,22426,35,111,22430,22434,58,22432,35,105,22436,22440,58,22438,35,110,22442,75,58,22444,35,35,22448,73,66,66,22452,22466,66,22454,66,22456,66,22458,66,22460,67,22462,22464,73,66,66,22468,22476,66,22470,66,22472,66,22474,66,67,22478,22488,66,22480,66,22482,66,22484,66,22486,66,67,22490,22498,66,22492,66,22494,66,22496,66,89,22500,22572,82,22502,22504,22510,66,22506,66,22508,66,67,22512,22520,66,22514,66,22516,66,22518,66,67,22522,22534,66,22524,67,22526,22528,22530,66,66,22532,66,66,66,67,22536,22538,22540,66,67,22542,22546,66,22544,66,67,22548,22564,66,22550,67,22552,22554,22556,66,66,22558,22562,3158,22560,924,878,67,66,22566,22570,66,22568,66,836,67,832,22574,22576,66,66,22578,22580,66,83,22582,22586,66,22584,66,67,22588,22594,66,22590,66,22592,66,67,22596,22604,66,22598,66,22600,66,22602,66,67,22606,22616,66,22608,66,22610,66,22612,66,22614,66,83,22618,22630,66,22620,66,22622,66,22624,66,22626,66,22628,66,83,22632,22784,83,22634,22636,22638,66,83,22640,22644,66,22642,66,83,22646,22652,66,22648,66,22650,66,66,22654,22660,66,22656,66,22658,66,67,22662,22670,66,22664,66,22666,66,22668,66,83,22672,22682,66,22674,66,22676,66,22678,66,22680,66,83,22684,22700,66,22686,66,22688,66,22690,67,22692,22694,22696,66,66,22698,73,66,66,22702,22706,66,22704,66,67,22708,22714,66,22710,66,22712,66,67,22716,22724,66,22718,66,22720,66,22722,66,67,22726,22738,66,22728,66,22730,66,22732,66,22734,66,22736,802,1906,22740,22744,82,22742,84,75,22746,22748,66,66,22750,22752,66,67,22754,22758,66,22756,66,66,22760,22764,66,22762,66,67,22766,22774,66,22768,66,22770,66,22772,814,1840,22776,22778,66,67,22780,532,66,22782,67,22200,22786,22968,66,22788,67,22790,22792,22794,66,67,22796,22800,66,22798,66,67,22802,22808,66,22804,66,22806,66,66,22810,22816,66,22812,66,22814,66,67,22818,22826,66,22820,66,22822,66,22824,66,66,22828,22836,66,22830,66,22832,66,22834,66,67,22838,22852,66,22840,82,22842,22844,22846,66,67,22848,67,66,22850,66,67,22854,22858,66,22856,66,66,22860,22864,66,22862,66,83,22866,22872,66,22868,66,22870,66,67,22874,22882,66,22876,66,22878,66,22880,66,83,22884,22896,66,22886,66,22888,66,22890,67,22892,22894,73,66,66,22898,22900,66,67,22902,22906,66,22904,66,67,22908,22916,66,22910,66,22912,66,22914,802,1906,22918,22966,66,22920,66,22922,67,22924,22926,22930,66,22928,814,1840,22932,22934,66,492,454,22936,22938,22942,58,22940,35,106,22944,22948,58,22946,35,111,22950,22954,58,22952,35,105,22956,22960,58,22958,35,110,22962,75,58,22964,35,35,84,75,22970,22972,66,67,22974,532,66,22976,67,8226,22980,23000,66,22982,66,22984,83,22986,22988,22990,66,83,22992,22996,82,22994,812,1856,22998,3660,66,66,23002,23012,66,23004,66,23006,66,23008,66,23010,66,75,23014,23022,66,23016,66,23018,66,23020,66,84,23024,23034,66,23026,66,23028,66,23030,66,23032,66,75,23036,23312,83,23038,23040,23042,66,67,23044,23048,66,23046,66,67,23050,23056,66,23052,66,23054,66,67,23058,23066,66,23060,66,23062,66,23064,66,66,23068,23162,82,23070,23072,23082,66,23074,66,23076,66,23078,66,23080,812,1856,23084,23086,66,67,23088,23092,66,23090,66,67,23094,23100,66,23096,66,23098,66,492,23102,23140,66,23104,66,23106,66,23108,454,23110,23112,23116,58,23114,35,106,23118,23122,58,23120,35,111,23124,23128,58,23126,35,105,23130,23134,58,23132,35,110,23136,75,58,23138,35,35,23142,23148,66,23144,66,23146,1582,492,23150,532,66,23152,67,23154,23156,23158,66,492,23160,3700,66,532,23164,23166,66,66,23168,23170,66,67,23172,23176,66,23174,66,66,23178,23182,66,23180,66,83,23184,23192,66,23186,66,23188,66,23190,802,1906,23194,23202,66,23196,66,23198,23200,1840,1288,1856,23204,23208,66,23206,66,84,23210,23300,66,23212,67,23214,23216,23218,66,67,23220,23224,66,23222,66,67,23226,23288,66,23228,82,23230,23232,23236,66,23234,812,1856,23238,23276,66,23240,23242,23244,1250,454,532,23246,23248,23252,58,23250,35,106,23254,23258,58,23256,35,111,23260,23264,58,23262,35,105,23266,23270,58,23268,35,110,23272,75,58,23274,35,35,23278,23280,814,1674,75,23282,23284,75,58,23286,35,95,23290,23294,66,23292,66,66,67,23296,3458,23298,924,878,23302,23306,82,23304,84,75,23308,23310,66,66,21678,22344,23314,23322,66,23316,66,23318,23320,73,1202,1476,67,23324,3458,23326,924,878,23330,23334,66,23332,66,84,23336,23338,66,67,23340,23344,66,23342,66,66,23346,23348,82,832,23350,814,66,66,23354,23478,82,23356,23358,23360,66,89,23362,23370,66,23364,66,23366,82,23368,75,144,23372,23448,66,23374,83,23376,23378,23380,66,67,23382,23436,83,23384,23386,23388,66,67,23390,23414,66,23392,67,23394,23396,23408,83,23398,23400,23402,83,73,23404,23406,66,75,812,1856,23410,23412,66,75,812,1856,23416,73,83,23418,23420,23422,66,67,23424,23428,66,23426,66,66,66,23430,23432,492,23434,1856,848,1840,67,23438,23440,23442,66,66,23444,454,66,23446,814,1840,23450,23476,66,23452,67,23454,23456,23458,66,67,23460,23466,66,23462,66,23464,802,1906,23468,23474,66,23470,23472,1840,1288,1856,23328,1840,21678,22344,23480,23482,66,66,23484,23534,66,23486,83,23488,23490,23492,66,67,23494,23496,66,84,23498,23500,66,84,23502,23508,66,23504,66,23506,66,778,23510,23518,66,23512,67,23514,23516,832,66,66,23520,23524,66,23522,66,15740,23526,23532,66,23528,82,23530,35,0,66,1940,23536,23540,66,23538,66,84,23542,23548,66,23544,66,23546,66,84,23550,23560,66,23552,66,23554,66,23556,66,23558,66,774,23562,23576,66,23564,66,23566,67,23568,23570,23572,66,66,23574,832,66,66,23578,23588,66,23580,66,23582,67,23584,23586,832,66,66,23590,23612,82,23592,23594,23596,66,1024,23598,23602,66,23600,66,15740,23604,23610,66,23606,82,23608,35,0,66,1940,23614,814,66,66,23618,23622,66,23620,66,84,23624,23748,82,23626,23628,23632,66,23630,66,84,23634,23644,66,23636,66,23638,67,23640,23642,73,66,66,23646,23654,66,23648,66,23650,66,23652,66,75,23656,23670,83,23658,23660,23662,66,66,23664,23666,66,66,23668,832,66,66,23672,23698,66,23674,67,23676,23678,23680,66,66,23682,23684,66,83,23686,23690,66,23688,66,832,67,23692,23694,23696,66,400,1664,1008,23700,23706,66,23702,82,23704,1664,1012,23708,23712,66,23710,66,83,23714,23722,66,23716,66,23718,66,23720,1250,454,23724,23726,66,67,23728,23744,82,23730,23732,23738,66,23734,67,23736,1582,492,1664,23740,23742,1012,66,532,23746,8038,66,66,23750,23752,66,66,23754,23756,66,66,23758,23760,66,67,23762,23770,66,23764,66,23766,67,23768,814,1966,23772,20380,82,23774,23776,23778,832,75,35,0,23782,23792,66,23784,66,23786,67,23788,23790,73,66,66,23794,23890,66,23796,66,23798,66,23800,83,23802,23804,23806,66,67,23808,23814,66,23810,66,23812,814,1966,23816,23820,66,23818,66,84,23822,23828,66,23824,66,23826,66,84,23830,23850,82,23832,23834,23842,82,23836,23838,832,66,23840,66,836,23844,23846,66,66,23848,66,66,66,23852,23854,66,66,23856,23858,66,83,23860,23864,66,23862,66,67,23866,23872,66,23868,66,23870,66,66,23874,23880,66,23876,66,23878,66,832,67,23882,23884,23886,66,67,2914,23888,924,878,23892,21476,83,23894,23896,23898,66,83,23900,23904,66,23902,66,67,23906,23912,66,23908,66,23910,66,83,23914,23924,66,23916,66,23918,67,23920,23922,73,66,66,23926,23932,66,23928,66,23930,66,84,23934,24002,82,23936,23938,23946,66,23940,66,23942,66,23944,66,1008,23948,23996,66,23950,82,23952,23954,23956,82,75,23958,23960,66,836,23962,832,82,23964,712,23966,23968,23972,58,23970,35,115,23974,23978,58,23976,35,101,23980,23984,58,23982,35,108,23986,23990,58,23988,35,102,23992,75,58,23994,35,33,23998,18658,66,24000,66,66,24004,24006,66,66,24008,24010,66,66,24012,24014,66,83,24016,23616,66,24018,66,66,24022,24034,82,24024,67,24026,24028,24032,66,24030,814,1674,23352,1674,24036,24038,66,66,24040,24042,66,83,24044,24048,66,24046,66,67,24050,24094,66,24052,82,24054,24056,24084,83,24058,24060,24062,66,832,24064,75,1250,24066,24068,73,82,24070,24072,24074,66,84,24076,24080,66,24078,66,75,2914,24082,924,878,24086,24088,66,1652,24090,24092,814,1674,1024,1012,24096,24100,66,24098,66,66,24102,23780,66,24104,66,24106,24108,2012,1352,1980,24112,84,66,24114,82,24110,24118,24120,82,24110,24122,73,82,1476,24126,24158,82,24128,24130,24138,66,24132,83,24134,24136,73,82,75,24140,24144,66,24142,66,75,24146,24150,66,24148,66,75,24152,24154,82,24124,24156,836,66,66,24160,73,82,146,24164,24172,66,24166,67,24168,24170,73,82,75,24174,24182,66,24176,67,24178,24180,1652,66,66,24184,1652,66,1676,24188,24408,82,24190,24192,24196,66,24194,82,144,24198,24298,82,24200,24202,24204,66,67,24206,24210,66,24208,66,67,24212,24222,66,24214,66,24216,82,24218,24220,75,66,75,24224,24230,66,24226,66,24228,66,83,24232,24238,66,24234,66,24236,82,75,24240,24246,66,24242,66,24244,66,83,24248,24260,66,24250,67,24252,24254,24256,66,66,24258,73,66,66,24262,24266,66,24264,66,67,24268,24292,66,24270,66,24272,67,24274,24276,24280,800,24278,1060,874,24282,24286,58,24284,35,45,24288,75,58,24290,35,62,24294,24186,66,24296,67,836,24300,24302,66,83,24304,24308,66,24306,66,83,24310,24314,66,24312,82,75,24316,24320,66,24318,66,83,24322,24400,82,24324,24326,24328,66,67,24330,24334,66,24332,82,73,24336,24340,66,24338,66,83,24342,24368,66,24344,67,24346,24348,24350,66,66,24352,24356,800,24354,1060,874,24358,24362,58,24360,35,73,24364,75,58,24366,35,79,24370,24376,82,24372,24374,75,66,75,24378,24380,66,83,24382,24384,82,75,24386,24388,66,66,24390,73,82,24392,24394,24396,82,75,24398,722,66,836,24402,24404,66,66,24406,73,66,66,24410,24420,82,24412,24414,24416,82,75,24418,712,66,836,24422,73,82,24424,24426,24428,82,75,24430,722,66,836,24434,24436,82,146,24438,24444,82,24440,24442,75,66,75,24446,24448,66,83,24450,24452,82,75,24454,24456,66,83,24458,24618,82,24460,24462,24512,66,24464,83,24466,24468,24494,82,24470,24472,24476,58,24474,35,118,24478,24482,58,24480,35,111,24484,24488,58,24486,35,105,24490,75,58,24492,35,100,24496,24500,800,24498,1060,874,24502,24506,58,24504,35,40,24508,75,58,24510,35,41,24514,24564,66,24516,83,24518,24520,24540,82,24522,24524,24528,58,24526,35,105,24530,24534,58,24532,35,110,24536,75,58,24538,35,116,24542,24546,800,24544,1060,874,24548,24552,58,24550,35,73,24554,24558,58,24556,35,110,24560,75,58,24562,35,116,67,24566,24568,24588,82,24570,24572,24576,58,24574,35,105,24578,24582,58,24580,35,110,24584,75,58,24586,35,116,24590,24594,800,24592,1060,874,24596,24600,58,24598,35,67,24602,24606,58,24604,35,104,24608,24612,58,24610,35,97,24614,75,58,24616,35,114,24620,73,66,66,24624,73,82,24626,24628,24630,82,24186,24632,24634,66,66,24636,24640,66,24638,66,1656,24642,24654,66,24644,83,24646,24648,24650,66,836,24652,24116,66,24432,24656,24668,66,24658,66,24660,836,24662,24664,75,58,24666,35,32,24670,24734,82,24672,24674,24684,66,24676,836,24678,24680,75,58,24682,35,40,24686,24710,82,24688,24690,75,836,24692,24694,24698,58,24696,35,41,24700,24704,58,24702,35,59,24706,75,58,24708,35,10,24712,24714,66,836,24716,24726,66,24718,24162,24720,24722,75,58,24724,35,44,24728,24124,66,24730,24732,24432,814,1674,24736,836,66,66,24740,24744,66,24742,82,144,24746,24790,83,24748,24750,24752,66,67,24754,24758,66,24756,66,83,24760,24764,66,24762,82,75,24766,24770,66,24768,66,66,24772,24774,66,84,24776,24782,66,24778,66,24780,832,75,67,24784,24786,24788,66,832,832,75,24792,24794,66,67,24796,24800,66,24798,66,67,24802,24952,83,24804,24806,24808,66,67,24810,24814,66,24812,66,83,24816,24822,66,24818,66,24820,66,83,24824,24830,66,24826,66,24828,82,75,24832,24838,66,24834,66,24836,66,83,24840,24852,66,24842,67,24844,24846,24848,66,66,24850,73,66,66,24854,24858,66,24856,66,67,24860,24866,66,24862,66,24864,82,73,24868,24874,66,24870,66,24872,66,83,24876,24904,66,24878,66,24880,67,24882,24884,24886,66,66,24888,24892,800,24890,1060,874,24894,24898,58,24896,35,73,24900,75,58,24902,35,79,24906,24914,66,24908,82,24910,24912,75,66,75,24916,24920,66,24918,66,83,24922,24926,66,24924,82,75,24928,24932,66,24930,66,66,24934,24936,66,84,24938,24944,66,24940,66,24942,832,75,67,24946,24948,24950,66,832,832,846,24954,24962,66,24956,66,24958,66,24960,66,75,24964,24968,66,24966,66,67,24970,24980,66,24972,66,24974,82,24976,24978,75,66,75,24982,24988,66,24984,66,24986,66,83,24990,24996,66,24992,66,24994,82,75,24998,25004,66,25000,66,25002,66,83,25006,25016,66,25008,66,25010,67,25012,25014,73,66,66,25018,25022,66,25020,66,67,25024,25048,66,25026,66,25028,67,25030,25032,25036,800,25034,1060,874,25038,25042,58,25040,35,45,25044,75,58,25046,35,62,25050,25138,83,25052,25054,25056,66,66,25058,25060,66,1018,25062,25064,66,1652,25066,25098,83,25068,25070,25072,66,1652,25074,25076,82,75,25078,25092,82,25080,25082,25086,58,25084,35,44,25088,75,58,25090,35,32,25094,25096,798,878,35,3,25100,25128,66,25102,1652,25104,25106,25110,58,25108,35,110,25112,25116,58,25114,35,117,25118,25122,58,25120,35,109,25124,75,58,25126,35,40,25130,4082,82,25132,25134,75,58,25136,35,41,25140,25142,66,24738,25144,136,82,25146,35,1,25150,25158,66,25152,67,25154,25156,73,82,73,25160,25168,66,25162,67,25164,25166,73,66,66,25170,25182,66,25172,66,25174,66,25176,67,25178,24738,25180,35,2,25184,25192,66,25186,66,25188,66,25190,66,84,25194,25208,66,25196,66,25198,66,25200,66,25202,67,25204,25206,73,66,66,25210,25450,66,25212,66,25214,66,25216,82,25218,25220,25270,66,25222,67,25224,25226,25228,66,83,25230,25266,82,25232,66,25234,1652,25236,25238,25242,58,25240,35,39,25244,25248,58,25246,35,73,25250,25254,58,25252,35,39,25256,25260,58,25258,35,44,25262,75,58,25264,35,32,25268,73,66,66,25272,25328,66,25274,66,25276,66,25278,1652,25280,25282,25286,58,25284,35,97,25288,25292,58,25290,35,112,25294,25298,58,25296,35,112,25300,25304,58,25302,35,40,25306,25310,58,25308,35,97,25312,25316,58,25314,35,114,25318,25322,58,25320,35,103,25324,75,58,25326,35,40,25330,25350,83,25332,25334,25336,66,66,25338,25340,66,66,25342,25344,66,4082,25346,136,82,25348,35,1,25352,25378,66,25354,66,25356,66,25358,1652,25360,25362,25366,58,25364,35,41,25368,25372,58,25370,35,44,25374,75,58,25376,35,32,25380,25384,66,25382,67,66,25386,25434,66,25388,66,25390,1652,25392,25394,25398,58,25396,35,41,25400,25404,58,25402,35,44,25406,25410,58,25408,35,32,25412,25416,58,25414,35,97,25418,25422,58,25420,35,114,25424,25428,58,25426,35,103,25430,75,58,25432,35,40,25436,25446,82,25438,1652,25440,25442,75,58,25444,35,41,25448,4082,66,66,25452,25460,66,25454,66,25456,66,25458,66,83,25462,25472,66,25464,66,25466,66,25468,66,25470,66,83,25474,25486,66,25476,66,25478,66,25480,66,25482,66,25484,66,67,25488,25670,66,25490,82,25492,25494,25654,82,25496,25498,25514,66,25500,66,25502,66,25504,66,25506,1652,25508,25510,75,58,25512,35,40,25516,25642,82,25518,25520,25546,66,25522,66,25524,66,25526,1652,25528,25530,25534,58,25532,35,41,25536,25540,58,25538,35,59,25542,75,58,25544,35,32,25548,25586,66,25550,66,25552,66,25554,1652,25556,25558,25562,58,25560,35,108,25564,25568,58,25566,35,97,25570,25574,58,25572,35,122,25576,25580,58,25578,35,121,25582,75,58,25584,35,40,25588,25606,66,25590,82,25592,1652,25594,25596,25600,58,25598,35,44,25602,75,58,25604,35,32,25608,25612,66,25610,66,66,25614,25618,66,25616,66,4082,25620,25636,83,25622,25624,25626,66,67,25628,25630,66,84,25632,134,82,25634,35,1,25638,136,82,25640,35,1,25644,25646,66,66,25648,25650,66,66,25652,1652,66,66,25656,25658,66,66,25660,25662,66,66,25664,25666,66,66,25668,1652,66,66,25672,25676,66,25674,66,66,25678,25682,66,25680,66,66,25684,25688,66,25686,66,66,25690,25694,66,25692,66,66,25696,25700,66,25698,66,67,25702,25708,66,25704,66,25706,66,67,25710,25754,66,25712,66,25714,66,25716,66,25718,66,25720,66,25722,1652,25724,25726,25730,58,25728,35,99,25732,25736,58,25734,35,97,25738,25742,58,25740,35,115,25744,25748,58,25746,35,101,25750,75,58,25752,35,32,25756,25778,83,25758,25760,25762,66,66,25764,25766,66,66,25768,25770,66,66,25772,25774,66,66,25776,4082,66,66,25780,25806,66,25782,66,25784,66,25786,66,25788,66,25790,66,25792,1652,25794,25796,25800,58,25798,35,58,25802,75,58,25804,35,32,25808,25992,83,25810,25812,25814,66,83,25816,25820,66,25818,66,67,25822,25828,66,25824,66,25826,66,83,25830,25838,66,25832,66,25834,66,25836,66,83,25840,25874,66,25842,66,25844,67,25846,25848,25850,66,66,25852,25854,66,66,25856,25870,82,25858,25860,25864,58,25862,35,40,25866,75,58,25868,35,41,800,25872,1060,874,25876,25884,66,25878,66,25880,66,25882,67,66,25886,25918,66,25888,66,25890,67,25892,25894,25896,66,66,84,25898,1652,25900,25902,25906,58,25904,35,39,25908,25912,58,25910,35,75,25914,75,58,25916,35,39,25920,25982,66,25922,66,25924,66,25926,1652,25928,25930,25934,58,25932,35,41,25936,25940,58,25938,35,59,25942,25946,58,25944,35,32,25948,25952,58,25950,35,98,25954,25958,58,25956,35,114,25960,25964,58,25962,35,101,25966,25970,58,25968,35,97,25972,25976,58,25974,35,107,25978,75,58,25980,35,59,25984,25986,66,25148,25988,134,82,25990,35,1,25994,26048,66,25996,66,25998,66,26000,66,26002,66,26004,1652,26006,26008,26012,58,26010,35,123,26014,26018,58,26016,35,117,26020,26024,58,26022,35,32,26026,26030,58,26028,35,114,26032,26036,58,26034,35,32,26038,26042,58,26040,35,61,26044,75,58,26046,35,32,26050,26058,66,26052,66,26054,66,26056,67,66,26060,26140,66,26062,66,26064,67,26066,26068,26070,66,66,84,26072,1652,26074,26076,26080,58,26078,35,97,26082,26086,58,26084,35,112,26088,26092,58,26090,35,112,26094,26098,58,26096,35,40,26100,26104,58,26102,35,39,26106,26110,58,26108,35,35,26112,26116,58,26114,35,39,26118,26122,58,26120,35,44,26124,26128,58,26126,35,32,26130,26134,58,26132,35,114,26136,75,58,26138,35,41,26142,26216,66,26144,66,26146,66,26148,1652,26150,26152,26156,58,26154,35,41,26158,26162,58,26160,35,59,26164,26168,58,26166,35,32,26170,26174,58,26172,35,98,26176,26180,58,26178,35,114,26182,26186,58,26184,35,101,26188,26192,58,26190,35,97,26194,26198,58,26196,35,107,26200,26204,58,26202,35,59,26206,26210,58,26208,35,125,26212,75,58,26214,35,10,26218,26220,66,25148,26222,134,82,26224,35,1,26228,26232,26230,826,802,1424,26234,26240,82,26236,26238,75,812,1400,26242,26252,83,26244,26246,26250,82,26248,35,255,798,878,26254,26256,82,26226,26258,26262,66,26260,814,1430,26264,73,66,836,26268,26430,82,26270,26272,73,82,26274,26276,26326,82,26278,26280,26282,66,778,1652,26284,26286,26290,58,26288,35,100,26292,26296,58,26294,35,114,26298,26302,58,26300,35,101,26304,26308,58,26306,35,103,26310,26314,58,26312,35,115,26316,26320,58,26318,35,58,26322,75,58,26324,35,32,26328,26330,66,83,26332,26342,66,26334,67,26336,26338,75,800,26340,1060,874,26344,26408,82,26346,26348,26372,66,26350,66,26352,66,26354,82,26356,26358,26364,66,26360,66,26362,66,774,26366,832,66,26368,66,26370,67,832,26374,26382,66,26376,66,26378,66,26380,66,66,26384,26392,66,26386,66,26388,66,26390,66,66,26394,26402,66,26396,66,26398,66,26400,82,778,26404,24020,66,26406,66,67,26410,26428,66,26412,26414,26416,1250,73,26418,75,26420,75,26422,75,26424,11642,26426,75,360,75,1652,11308,26432,11262,82,26434,778,26436,26438,26442,58,26440,35,112,26444,26448,58,26446,35,97,26450,26454,58,26452,35,114,26456,26460,58,26458,35,115,26462,26466,58,26464,35,101,26468,26472,58,26470,35,32,26474,26478,58,26476,35,101,26480,26484,58,26482,35,114,26486,26490,58,26488,35,114,26492,26496,58,26494,35,111,26498,75,58,26500,35,114,26504,26988,66,26506,1652,26508,26510,26514,58,26512,35,105,26516,26520,58,26518,35,110,26522,26526,58,26524,35,116,26528,26532,58,26530,35,32,26534,26538,58,26536,35,109,26540,26544,58,26542,35,97,26546,26550,58,26548,35,105,26552,26556,58,26554,35,110,26558,26562,58,26560,35,40,26564,26568,58,26566,35,105,26570,26574,58,26572,35,110,26576,26580,58,26578,35,116,26582,26586,58,26584,35,32,26588,26592,58,26590,35,97,26594,26598,58,26596,35,114,26600,26604,58,26602,35,103,26606,26610,58,26608,35,99,26612,26616,58,26614,35,44,26618,26622,58,26620,35,99,26624,26628,58,26626,35,104,26630,26634,58,26632,35,97,26636,26640,58,26638,35,114,26642,26646,58,26644,35,42,26648,26652,58,26650,35,42,26654,26658,58,26656,35,97,26660,26664,58,26662,35,114,26666,26670,58,26668,35,103,26672,26676,58,26674,35,118,26678,26682,58,26680,35,41,26684,26688,58,26686,35,123,26690,26694,58,26692,35,101,26696,26700,58,26698,35,110,26702,26706,58,26704,35,118,26708,26712,58,26710,35,95,26714,26718,58,26716,35,97,26720,26724,58,26722,35,114,26726,26730,58,26728,35,103,26732,26736,58,26734,35,99,26738,26742,58,26740,35,61,26744,26748,58,26746,35,97,26750,26754,58,26752,35,114,26756,26760,58,26758,35,103,26762,26766,58,26764,35,99,26768,26772,58,26770,35,59,26774,26778,58,26776,35,101,26780,26784,58,26782,35,110,26786,26790,58,26788,35,118,26792,26796,58,26794,35,95,26798,26802,58,26800,35,97,26804,26808,58,26806,35,114,26810,26814,58,26812,35,103,26816,26820,58,26818,35,118,26822,26826,58,26824,35,61,26828,26832,58,26830,35,97,26834,26838,58,26836,35,114,26840,26844,58,26842,35,103,26846,26850,58,26848,35,118,26852,26856,58,26854,35,59,26858,26862,58,26860,35,114,26864,26868,58,26866,35,116,26870,26874,58,26872,35,115,26876,26880,58,26878,35,95,26882,26886,58,26884,35,105,26888,26892,58,26890,35,110,26894,26898,58,26896,35,105,26900,26904,58,26902,35,116,26906,26910,58,26908,35,40,26912,26916,58,26914,35,41,26918,26922,58,26920,35,59,26924,26928,58,26926,35,114,26930,26934,58,26932,35,116,26936,26940,58,26938,35,115,26942,26946,58,26944,35,95,26948,26952,58,26950,35,114,26954,26958,58,26956,35,101,26960,26964,58,26962,35,100,26966,26970,58,26968,35,117,26972,26976,58,26974,35,99,26978,26982,58,26980,35,101,26984,75,58,26986,35,40,26990,4082,82,26992,26994,26998,58,26996,35,41,27000,27004,58,27002,35,59,27006,27010,58,27008,35,114,27012,27016,58,27014,35,101,27018,27022,58,27020,35,116,27024,27028,58,27026,35,117,27030,27034,58,27032,35,114,27036,27040,58,27038,35,110,27042,27046,58,27044,35,32,27048,27052,58,27050,35,48,27054,27058,58,27056,35,59,27060,27064,58,27062,35,125,27066,75,58,27068,35,10,27072,28672,82,27074,27076,73,82,27078,27080,28668,82,27082,27084,27086,66,75,27088,28664,82,27090,27092,28650,82,27094,27096,27138,66,27098,82,27100,27102,27108,66,27104,27106,26502,1202,75,27110,27114,3458,27112,924,878,27116,27120,58,27118,35,109,27122,27126,58,27124,35,97,27128,27132,58,27130,35,105,27134,75,58,27136,35,110,27140,27144,66,27142,66,83,27146,27152,66,27148,66,27150,66,67,27154,27178,83,27156,27158,27160,66,66,27162,27164,66,66,27166,27168,66,66,27170,27172,66,66,27174,27176,66,1652,1676,24622,27180,27438,66,27182,66,27184,66,27186,66,27188,66,27190,1652,27192,27194,27198,58,27196,35,115,27200,27204,58,27202,35,116,27206,27210,58,27208,35,97,27212,27216,58,27214,35,116,27218,27222,58,27220,35,105,27224,27228,58,27226,35,99,27230,27234,58,27232,35,32,27236,27240,58,27238,35,118,27242,27246,58,27244,35,111,27248,27252,58,27250,35,105,27254,27258,58,27256,35,100,27260,27264,58,27262,35,32,27266,27270,58,27268,35,102,27272,27276,58,27274,35,111,27278,27282,58,27280,35,114,27284,27288,58,27286,35,101,27290,27294,58,27292,35,105,27296,27300,58,27298,35,103,27302,27306,58,27304,35,110,27308,27312,58,27310,35,40,27314,27318,58,27316,35,117,27320,27324,58,27322,35,32,27326,27330,58,27328,35,110,27332,27336,58,27334,35,41,27338,27342,58,27340,35,32,27344,27348,58,27346,35,123,27350,27354,58,27352,35,10,27356,27360,58,27358,35,32,27362,27366,58,27364,35,32,27368,27372,58,27370,35,115,27374,27378,58,27376,35,119,27380,27384,58,27382,35,105,27386,27390,58,27388,35,116,27392,27396,58,27394,35,99,27398,27402,58,27400,35,104,27404,27408,58,27406,35,40,27410,27414,58,27412,35,110,27416,27420,58,27418,35,41,27422,27426,58,27424,35,32,27428,27432,58,27430,35,123,27434,75,58,27436,35,10,27440,28616,82,27442,27444,27496,66,27446,66,27448,66,27450,66,27452,1652,27454,27456,27460,58,27458,35,10,27462,27466,58,27464,35,32,27468,27472,58,27470,35,32,27474,27478,58,27476,35,125,27480,27484,58,27482,35,10,27486,27490,58,27488,35,125,27492,75,58,27494,35,10,27498,27646,66,27500,66,27502,66,27504,66,27506,1652,27508,27510,27514,58,27512,35,115,27516,27520,58,27518,35,116,27522,27526,58,27524,35,97,27528,27532,58,27530,35,116,27534,27538,58,27536,35,105,27540,27544,58,27542,35,99,27546,27550,58,27548,35,32,27552,27556,58,27554,35,99,27558,27562,58,27560,35,111,27564,27568,58,27566,35,110,27570,27574,58,27572,35,115,27576,27580,58,27578,35,116,27582,27586,58,27584,35,32,27588,27592,58,27590,35,117,27594,27598,58,27596,35,32,27600,27604,58,27602,35,112,27606,27610,58,27608,35,114,27612,27616,58,27614,35,111,27618,27622,58,27620,35,103,27624,27628,58,27626,35,91,27630,27634,58,27632,35,93,27636,27640,58,27638,35,61,27642,75,58,27644,35,123,27648,27688,66,27650,66,27652,67,27654,27656,27658,66,66,27660,27666,66,27662,27664,73,1250,66,27668,27684,66,27670,1664,27672,27674,27680,82,27676,836,27678,35,44,27682,4082,66,66,27686,1012,82,75,27690,28034,66,27692,66,27694,66,27696,1652,27698,27700,27704,58,27702,35,125,27706,27710,58,27708,35,59,27712,27716,58,27714,35,10,27718,27722,58,27720,35,115,27724,27728,58,27726,35,116,27730,27734,58,27732,35,97,27736,27740,58,27738,35,116,27742,27746,58,27744,35,105,27748,27752,58,27750,35,99,27754,27758,58,27756,35,32,27760,27764,58,27762,35,99,27766,27770,58,27768,35,111,27772,27776,58,27774,35,110,27778,27782,58,27780,35,115,27784,27788,58,27786,35,116,27790,27794,58,27792,35,32,27796,27800,58,27798,35,117,27802,27806,58,27804,35,32,27808,27812,58,27810,35,112,27814,27818,58,27816,35,114,27820,27824,58,27822,35,111,27826,27830,58,27828,35,103,27832,27836,58,27834,35,95,27838,27842,58,27840,35,115,27844,27848,58,27846,35,105,27850,27854,58,27852,35,122,27856,27860,58,27858,35,101,27862,27866,58,27864,35,61,27868,27872,58,27870,35,115,27874,27878,58,27876,35,105,27880,27884,58,27882,35,122,27886,27890,58,27888,35,101,27892,27896,58,27894,35,111,27898,27902,58,27900,35,102,27904,27908,58,27906,35,40,27910,27914,58,27912,35,112,27916,27920,58,27918,35,114,27922,27926,58,27924,35,111,27928,27932,58,27930,35,103,27934,27938,58,27936,35,41,27940,27944,58,27942,35,47,27946,27950,58,27948,35,115,27952,27956,58,27954,35,105,27958,27962,58,27960,35,122,27964,27968,58,27966,35,101,27970,27974,58,27972,35,111,27976,27980,58,27978,35,102,27982,27986,58,27984,35,40,27988,27992,58,27990,35,42,27994,27998,58,27996,35,112,28000,28004,58,28002,35,114,28006,28010,58,28008,35,111,28012,28016,58,28014,35,103,28018,28022,58,28020,35,41,28024,28028,58,28026,35,59,28030,75,58,28032,35,10,28036,28146,66,28038,66,28040,66,28042,1652,28044,28046,28050,58,28048,35,115,28052,28056,58,28054,35,116,28058,28062,58,28060,35,97,28064,28068,58,28066,35,116,28070,28074,58,28072,35,105,28076,28080,58,28078,35,99,28082,28086,58,28084,35,32,28088,28092,58,28090,35,117,28094,28098,58,28096,35,32,28100,28104,58,28102,35,114,28106,28110,58,28108,35,111,28112,28116,58,28114,35,111,28118,28122,58,28120,35,116,28124,28128,58,28126,35,91,28130,28134,58,28132,35,93,28136,28140,58,28138,35,61,28142,75,58,28144,35,123,28148,28236,83,28150,28152,28154,66,67,28156,28160,66,28158,66,66,67,28162,28164,28166,82,73,28168,28170,66,1250,28172,28180,66,28174,67,28176,28178,73,66,66,28182,28186,66,28184,66,75,28188,28206,82,28190,66,28192,1652,28194,28196,28200,58,28198,35,44,28202,75,58,28204,35,32,28208,28210,66,66,28212,28214,66,67,28216,28220,66,28218,66,66,28222,28230,66,28224,66,28226,28228,4082,1202,1476,67,28232,3458,28234,924,878,28238,28262,66,28240,66,28242,1652,28244,28246,28250,58,28248,35,125,28252,28256,58,28254,35,59,28258,75,58,28260,35,10,28264,28420,66,28266,66,28268,1652,28270,28272,28276,58,28274,35,115,28278,28282,58,28280,35,116,28284,28288,58,28286,35,97,28290,28294,58,28292,35,116,28296,28300,58,28298,35,105,28302,28306,58,28304,35,99,28308,28312,58,28310,35,32,28314,28318,58,28316,35,99,28320,28324,58,28322,35,111,28326,28330,58,28328,35,110,28332,28336,58,28334,35,115,28338,28342,58,28340,35,116,28344,28348,58,28346,35,32,28350,28354,58,28352,35,117,28356,28360,58,28358,35,32,28362,28366,58,28364,35,114,28368,28372,58,28370,35,111,28374,28378,58,28376,35,111,28380,28384,58,28382,35,116,28386,28390,58,28388,35,95,28392,28396,58,28394,35,115,28398,28402,58,28400,35,105,28404,28408,58,28406,35,122,28410,28414,58,28412,35,101,28416,75,58,28418,35,61,28422,28432,83,28424,28426,28428,66,66,28430,1274,66,4082,28434,28452,66,28436,66,28438,1652,28440,28442,28446,58,28444,35,59,28448,75,58,28450,35,10,28454,28460,66,28456,28458,73,1250,66,28462,28468,82,28464,1756,28466,35,0,1770,28470,28472,28476,66,28474,66,1652,28478,28532,66,28480,66,28482,1652,28484,28486,28490,58,28488,35,69,28492,28496,58,28494,35,88,28498,28502,58,28500,35,80,28504,28508,58,28506,35,79,28510,28514,58,28512,35,82,28516,28520,58,28518,35,84,28522,28526,58,28524,35,40,28528,75,58,28530,35,102,28534,28564,66,28536,83,28538,28540,28542,66,1652,28544,4082,82,28546,28548,28552,58,28550,35,44,28554,28558,58,28556,35,32,28560,75,58,28562,35,34,28566,28608,82,28568,28570,28592,66,28572,1652,28574,28576,28580,58,28578,35,34,28582,28586,58,28584,35,44,28588,75,58,28590,35,32,28594,4082,82,28596,28598,28602,58,28600,35,41,28604,75,58,28606,35,10,28610,28612,66,66,28614,1008,66,1652,28618,28620,66,66,28622,28624,66,66,28626,28628,66,66,28630,28632,66,66,28634,73,83,28636,28638,28640,66,25148,28642,28646,82,28644,35,1,28648,1274,66,134,28652,28654,66,66,28656,28658,66,66,28660,28662,66,16052,84,75,28666,73,66,66,28670,73,66,66,28674,26266,82,73,28678,28904,66,28680,67,28682,28684,28840,82,28686,28688,28694,83,28690,28692,73,82,144,28696,28700,66,28698,66,75,28702,1652,66,28704,67,28706,28708,28710,82,73,28712,28714,82,19406,28716,28838,82,28718,28720,28724,58,28722,35,58,28726,28730,58,28728,35,33,28732,28736,58,28734,35,35,28738,28742,58,28740,35,36,28744,28748,58,28746,35,37,28750,28754,58,28752,35,38,28756,28760,58,28758,35,42,28762,28766,58,28764,35,43,28768,28772,58,28770,35,46,28774,28778,58,28776,35,47,28780,28784,58,28782,35,60,28786,28790,58,28788,35,61,28792,28796,58,28794,35,62,28798,28802,58,28800,35,63,28804,28808,58,28806,35,64,28810,28814,58,28812,35,92,28816,28820,58,28818,35,94,28822,28826,58,28824,35,124,28828,28832,58,28830,35,45,28834,75,58,28836,35,126,1612,874,28842,73,82,28844,28846,28870,82,28848,28850,28858,66,28852,66,28854,836,28856,35,34,28860,28866,82,28862,836,28864,35,34,28868,1652,66,66,28872,28896,82,28874,28876,28884,66,28878,66,28880,836,28882,35,39,28886,28892,82,28888,836,28890,35,39,28894,836,66,66,28898,28900,82,4082,28902,73,82,836,28906,29130,66,28908,83,28910,28912,28914,66,83,28916,28924,66,28918,82,28920,28922,75,66,75,28926,28930,66,28928,66,83,28932,28936,66,28934,82,75,28938,28942,66,28940,66,83,28944,29122,82,28946,28948,28950,66,67,28952,28956,66,28954,82,75,28958,28962,66,28960,66,83,28964,28968,66,28966,82,75,28970,28974,66,28972,66,83,28976,28980,66,28978,82,75,28982,28986,66,28984,66,83,28988,28996,66,28990,67,28992,28994,73,66,66,28998,29000,66,67,29002,29006,66,29004,82,73,29008,29012,66,29010,66,83,29014,29028,66,29016,67,29018,29020,29022,66,66,29024,29026,800,874,35,70,29030,29036,82,29032,29034,75,66,75,29038,29040,66,83,29042,29044,82,75,29046,29048,66,83,29050,29118,82,29052,67,29054,29056,29058,82,75,29060,29062,66,83,29064,29066,82,75,29068,29070,66,83,29072,29074,82,75,29076,29078,66,66,29080,73,82,29082,29084,29114,66,29086,66,29088,1652,29090,29092,29096,58,29094,35,70,29098,29102,58,29100,35,70,29104,29108,58,29106,35,73,29110,75,58,29112,35,95,29116,73,66,4082,29120,73,66,66,29124,29126,66,66,29128,73,66,66,29132,29160,82,29134,29136,29150,82,29138,29140,29148,66,29142,66,29144,836,29146,35,32,28676,75,29152,29154,66,66,29156,29158,66,66,28676,846,29162,29164,66,66,29166,29168,66,66,29170,29172,82,73,29174,73,82,19406,29178,73,82,29180,29182,29234,82,29184,29186,29210,66,29188,66,29190,1652,29192,29194,29198,58,29196,35,32,29200,29204,58,29202,35,61,29206,75,58,29208,35,32,29212,29228,82,29214,1652,29216,29218,29222,58,29220,35,59,29224,75,58,29226,35,10,29230,29232,66,66,28676,846,29236,29238,66,66,29240,1652,66,66,29244,29280,82,29246,29248,73,82,29250,29252,29254,66,75,29256,73,82,29258,75,29260,29262,29268,66,29264,29266,75,1250,73,29270,29274,66,29272,1664,29176,29276,29278,66,15898,84,75,29282,26266,82,73,29286,73,82,29288,29290,29292,82,19424,29294,29296,66,66,29298,29300,66,66,29302,29308,66,29304,29306,73,1250,66,1664,19640,29312,29412,82,29314,29316,73,82,29318,29320,29322,66,75,29324,73,82,29326,29328,29330,66,75,29332,29338,66,29334,29336,73,82,75,29340,29346,66,29342,29344,73,1250,66,29348,3660,66,29350,1664,29352,29354,73,82,29356,29358,29404,82,29360,29362,29392,66,29364,66,29366,1652,29368,29370,29374,58,29372,35,32,29376,29380,58,29378,35,58,29382,29386,58,29384,35,58,29388,75,58,29390,35,32,29394,29400,82,29396,836,29398,35,10,29402,29284,66,66,29406,29408,66,66,29410,1652,66,66,29414,26266,82,73,29418,29434,83,29420,29422,29424,66,83,29426,29432,66,29428,66,29430,802,1424,67,816,29436,29462,66,29438,66,29440,83,29442,29444,29450,82,29446,29448,75,812,1400,29452,29456,82,29454,35,0,29458,73,66,29460,800,874,29464,29476,66,29466,66,29468,67,29470,29472,836,66,29474,814,1430,29478,29480,66,29416,29482,136,82,29484,35,1,29488,29492,29490,824,802,1424,29494,29506,66,29496,29498,29502,29500,1430,1288,1400,29416,29504,35,0,29508,29514,82,29510,1756,29512,35,1,29516,29518,66,1152,29520,134,82,29522,35,1,29526,29532,66,29528,29530,26226,802,1424,66,1438,29536,29540,29538,29486,802,1424,29542,29546,82,29544,29524,27070,29548,29636,82,29550,29552,29556,66,29554,66,75,29558,29598,66,29560,83,29562,29564,29568,82,29566,29524,29242,29570,29574,800,29572,1060,874,29576,29580,58,29578,35,99,29582,29586,58,29584,35,111,29588,29592,58,29590,35,109,29594,75,58,29596,35,98,67,29600,29602,29606,82,29604,29524,29310,29608,29612,800,29610,1060,874,29614,29618,58,29616,35,116,29620,29624,58,29622,35,121,29626,29630,58,29628,35,112,29632,75,58,29634,35,101,29638,73,66,83,};
static const u prog_size=sizeof(prog)/sizeof(*prog);
static u root[]={};
static const u root_size=0;
int main(int argc,char**argv){env_argc=argc;env_argv=argv;rts_init();rts_reduce(29534);return 0;}
